;****************************************************************************
;****************************************************************************
;*
;* c64memory.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef C64MEMORY_INC
%define C64MEMORY_INC

%include "defines.inc"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef C64MEMORY_NASM
global c64memory_initialize
global c64memory_create_instance
global c64memory_destroy_instance
global c64memory_reset
global c64memory_dump
global c64memory_read_opcode
global c64memory_read_stack
global c64memory_read_data
global c64memory_write_stack
global c64memory_write_data
global ab__c64_character_rom
%else
extern c64memory_initialize
extern c64memory_create_instance
extern c64memory_destroy_instance
extern c64memory_reset
extern c64memory_dump
extern c64memory_read_opcode
extern c64memory_read_stack
extern c64memory_read_data
extern c64memory_write_stack
extern c64memory_write_data
extern ab__c64_character_rom
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
					struc c64memory
					alignb 4
d__c64memory_modul_id:			resd	1
d__c64memory_state:			resd	1
b__c64memory_cpu6510_ddr:		resb	1
b__c64memory_cpu6510_io:		resb	1
b__c64memory_cpu6510_data:		resb	1
b__c64memory_cpu6510_mask:		resb	1
d__c64memory_read_opcode_low_limit:	resd	1
d__c64memory_read_opcode_high_limit:	resd	1
ab__c64memory_ram:			resb	010000h
ab__c64memory_color_ram:		resb	000400h
					endstruc



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%define C64MEMORY_MODUL_ID			esi + memory__c64 + d__c64memory_modul_id
%define C64MEMORY_STATE				esi + memory__c64 + d__c64memory_state
%define C64MEMORY_CPU6510_DDR			esi + memory__c64 + b__c64memory_cpu6510_ddr
%define C64MEMORY_CPU6510_IO			esi + memory__c64 + b__c64memory_cpu6510_io
%define C64MEMORY_CPU6510_DATA			esi + memory__c64 + b__c64memory_cpu6510_data
%define C64MEMORY_CPU6510_MASK			esi + memory__c64 + b__c64memory_cpu6510_mask
%define C64MEMORY_READ_OPCODE_LOW_LIMIT		esi + memory__c64 + d__c64memory_read_opcode_low_limit
%define C64MEMORY_READ_OPCODE_HIGH_LIMIT	esi + memory__c64 + d__c64memory_read_opcode_high_limit
%define C64MEMORY_RAM				esi + memory__c64 + ab__c64memory_ram
%define C64MEMORY_COLOR_RAM			esi + memory__c64 + ab__c64memory_color_ram
%define C64MEMORY_BASIC_ROM			ab__c64_basic_rom
%define C64MEMORY_CHARACTER_ROM			ab__c64_character_rom
%define C64MEMORY_KERNEL_ROM			ab__c64_kernel_rom



%assign C64MEMORY_STACK_LIMIT_EXCEEDED		000000001h


;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro C64MEMORY_CALL_CREATE_INSTANCE 0
			call	c64memory_create_instance
%endmacro



%macro C64MEMORY_CALL_DESTROY_INSTANCE 0
			call	c64memory_destroy_instance
%endmacro



%macro C64MEMORY_CALL_RESET 0
			call	c64memory_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

