;****************************************************************************
;****************************************************************************
;*
;* core_test.nasm
;*
;****************************************************************************
;****************************************************************************





%ifdef CORE_TEST_MODULE_CPU65XX
			;----------------------------------------
			;initialize only needed emulation modules
			;----------------------------------------

			call	system_restore
			PRINT_TEXT  .cb__message
			call	memory_initialize
			call	cpu65xx_initialize

			mov	dword esi, c64__1
			CPU65XX_CALL_CREATE_INSTANCE  memory_read, memory_read, memory_read, memory_write, memory_write
			CPU65XX_CALL_RESET

.test_pass_1:		call	write_pass
			xor	dword ebx, ebx
			call	memory_read
			mov	byte  [.b__end_flag], al
			mov	dword [.counter], 000001000h
.pass_1_run:		CPU65XX_CALL_CYCLE
			xor	dword ebx, ebx
			call	memory_read
			cmp	byte  [.b__end_flag], al
			jne	.pass_1_end
			dec	dword [.counter]
			jnz	.pass_1_run
			jmp	.pass_1_failed
.pass_1_end:		mov	dword ebx, 00000107fh
.pass_1_control:	call	memory_read
			cmp	byte  al, bl
			jne	.pass_1_failed
			dec	byte  bl
			jns	.pass_1_control
			call	write_passed
			jmp	.test_pass_2
.pass_1_failed:		call	write_failed

.test_pass_2:		call	write_pass
			xor	dword ebx, ebx
			call	memory_read
			mov	byte  [.b__end_flag], al
			mov	dword [.counter], 000000020h
.pass_2_run:		CPU65XX_CALL_CYCLE
			xor	dword ebx, ebx
			call	memory_read
			cmp	byte  [.b__end_flag], al
			jne	.pass_2_end
			dec	dword [.counter]
			jnz	.pass_2_run
			jmp	.pass_2_failed
.pass_2_end:		mov	dword ebx, 000001100h
                	call	memory_read
			cmp	byte  al, 080h
			jne	.pass_2_failed
			inc	byte  bl
			call	memory_read
			cmp	byte  al, 0c0h
			jne	.pass_2_failed
			call	write_passed
			jmp	.test_pass_3
.pass_2_failed:		call	write_failed

.test_pass_3:		call	write_pass
			xor	dword ebx, ebx
			call	memory_read
			mov	byte  [.b__end_flag], al
			mov	dword [.counter], 000000030h
.pass_3_run:		CPU65XX_CALL_CYCLE
			xor	dword ebx, ebx
			call	memory_read
			cmp	byte  [.b__end_flag], al
			jne	.pass_3_end
			dec	dword [.counter]
			jnz	.pass_3_run
			jmp	.pass_3_failed
.pass_3_end:		mov	dword ebx, 000001200h
                	call	memory_read
			cmp	byte  al, 002h
			jne	.pass_3_failed
			inc	byte  bl
			call	memory_read
			cmp	byte  al, 082h
			jne	.pass_3_failed
			call	write_passed
			jmp	.test_pass_4
.pass_3_failed:		call	write_failed

.test_pass_4:		call	write_pass
			xor	dword ebx, ebx
			call	memory_read
			mov	byte  [.b__end_flag], al
			mov	dword [.counter], 000000040h
.pass_4_run:		CPU65XX_CALL_CYCLE
			xor	dword ebx, ebx
			call	memory_read
			cmp	byte  [.b__end_flag], al
			jne	.pass_4_end
			dec	dword [.counter]
			jnz	.pass_4_run
			jmp	.pass_4_failed
.pass_4_end:		mov	dword ebx, 000001300h
                	call	memory_read
;			push	dword ebx
;			WRITE_HEX  2
;			pop	dword ebx
			cmp	byte  al, 011h
			jne	.pass_4_failed
			inc	byte  bl
			call	memory_read
;			push	dword ebx
;			WRITE_HEX  2
;			pop	dword ebx
			cmp	byte  al, 011h
			jne	.pass_4_failed
			inc	byte  bl
			call	memory_read
;			push	dword ebx
;			WRITE_HEX  2
;			pop	dword ebx
			cmp	byte  al, 080h
			jne	.pass_4_failed
			call	write_passed
			jmp	.test_pass_5
.pass_4_failed:		call	write_failed

.test_pass_5:
;			rdtsc
;			mov	dword ebx, eax
;			rdtsc
;			sub	dword eax, ebx
;			mov	byte bl, 007h
;			call	write_hex
			jmp	system_exit

.cb__message:		db	"CPU 65XX Emulation Selftest", 10, 0

section .data
			align 4
.counter:		dd	0
.b__end_flag:		db	0

;****************************************************************************
;* 64 KB Memory *************************************************************
;****************************************************************************
section .bss
ab__memory		resb	010000h



;****************************************************************************
;* memory_initialize ********************************************************
;****************************************************************************
section .text
memory_initialize:
			mov	dword ebx, .data
			xor	dword edx, edx
.get_count:
			mov	word  cx, [ebx]
			add	dword ebx, 02h
			test	word  cx, cx
			jz	.end
			mov	word  dx, [ebx]
			add	dword ebx, 02h
.write_bytes:
			mov	byte  al, [ebx]
			mov	byte [ab__memory + edx], al
			inc	dword ebx
			inc	word  dx
			dec	word  cx
			jnz	.write_bytes
			jmp	.get_count
.end:
			ret

section .data
.data:			dw	6
			dw	0fffch
			dw	08000h, 08000h, 08000h

			dw	.pass_1_end - .pass_1_start
			dw	08000h
.pass_1_start:		db	058h			;cli
			db	0a2h, 0ffh		;ldx #$ff
			db	09ah			;txs
			db	0a2h, 000h		;ldx #$00
			db	08ah			;txa
			db	09dh, 000h, 010h	;sta $1000,x
			db	0e8h			;inx
			db	010h, 0f9h		;bpl PC-$07
			db	0e6h, 000h		;inc $00
			db	04ch, 000h, 081h	;jmp $8100
.pass_1_end:
			dw	.pass_2_end - .pass_2_start
			dw	08100h
.pass_2_start:		db	0a9h, 080h		;lda #$80
			db	030h, 001h		;bmi PC+$01
			db	00ah			;asl
			db	08dh, 000h, 011h	;sta $1100
			db	038h			;sec
			db	090h, 001h		;bcc PC+$01
			db	06ah			;ror
			db	08dh, 001h, 011h	;sta $1101
			db	0e6h, 000h		;inc $00
			db	04ch, 000h, 082h	;jmp $8200
			db	0bah			;tsx
			db	0e8h			;inx
			db	0bdh, 000h, 001h	;lda $0100,x
			db	08dh, 000h, 012h	;sta $1200
			db	0e8h			;inx
			db	0bdh, 000h, 001h	;lda $0100,x
			db	08dh, 001h, 012h	;sta $1201
			db	060h			;rts
.pass_2_end:
			dw	.pass_3_end - .pass_3_start
			dw	08200h
.pass_3_start:		db	020h, 014h, 081h	;jsr $8114
			db	0e6h, 000h		;inc $00
			db	04ch, 000h, 083h	;jmp $8300
.pass_3_end:
			dw	.pass_4_end - .pass_4_start
			dw	08300h
.pass_4_start:		db	0f8h			;sed
			db	0a9h, 00ah		;lda #$0a
			db	018h			;clc
			db	069h, 001h		;adc #$01
			db	08dh, 000h, 013h	;sta $1300
			db	0a9h, 0a9h		;lda #$a9
			db	018h			;clc
			db	069h, 001h		;adc #$01
			db	08dh, 001h, 013h	;sta $1301
			db	0a9h, 0ffh		;lda #$ff
			db	018h			;clc
			db	069h, 000h		;adc #$00
			db	08dh, 002h, 013h	;sta $1302
			db	0e6h, 000h		;inc $00
.pass_4_end:
			dw	0


;****************************************************************************
;* memory_read **************************************************************
;****************************************************************************
section .text
memory_read:
			mov	byte  al, [ab__memory + ebx]
			ret



;****************************************************************************
;* memory_write *************************************************************
;****************************************************************************
section .text
memory_write:
			mov	byte  [ab__memory + ebx], al
			ret



;****************************************************************************
;* write_pass ***************************************************************
;****************************************************************************
section .text
write_pass:
			inc	dword [.d__pass_counter]
			PRINT_TEXT  .cb__pass, [.d__pass_counter]
			ret

.cb__pass:		db	"Pass ", STRING_INSERT_DEC32, " ...", 0

section .data
.d__pass_counter:	dd	0



;****************************************************************************
;* write_passed *************************************************************
;****************************************************************************
section .text
write_passed:
			PRINT_TEXT  .cb__passed
			ret

.cb__passed:		db	"passed", 10, 0



;****************************************************************************
;* write_failed *************************************************************
;****************************************************************************
section .text
write_failed:
			PRINT_TEXT  .cb__failed
			ret

.cb__failed:		db	"failed", 10, 0

%else
%error "no testcode enabled!"
%endif
;********************************************* karsten.scheibler@bigfoot.de *

