;****************************************************************************
;****************************************************************************
;*
;* link.nasm
;*
;****************************************************************************
;****************************************************************************





%define LINK_NASM
%include "link.inc"
%include "core.inc"
%include "c64link.inc"
%include "vc1541link.inc"



;****************************************************************************
;* local data ***************************************************************
;****************************************************************************
section .data
flag__atn_cleared:	db	0



;****************************************************************************
;* link_nothing *************************************************************
;****************************************************************************
section .text
link_nothing:
			ret



;****************************************************************************
;* link_keyboard ************************************************************
;****************************************************************************
section .text
link_keyboard:
			push	dword esi
			mov	dword esi, c64__1
			call	c64link_keyboard
			pop	dword esi
			ret



;****************************************************************************
;* link_status **************************************************************
;****************************************************************************
section .text
link_status:
			push	dword esi
			mov	dword esi, c64__1
			call	c64link_status
			mov	dword esi, vc1541__1
			call	vc1541link_status
%ifdef LINK_FRAME_PROFILING
%include "status.inc"
			call	status_frame_time
%endif
			pop	dword esi
			ret



;****************************************************************************
;* serial_bus ***************************************************************
;****************************************************************************
section .text
link_serial_bus:
			push	dword edi
			push	dword esi
			mov	dword esi, c64__1
			mov	byte  al, [C64LINK_SERIAL_BUS]
			mov	dword esi, vc1541__1
			mov	byte  bl, [VC1541LINK_SERIAL_BUS]
			test	byte  bl, 001h
			jz	.skip_set
			mov	byte  [flag__atn_cleared], 1
.skip_set:		test	byte  al, 001h
			jz	.clear
			test	byte  [flag__atn_cleared], NOT8
			jnz	.no_data_influence
			or	byte  al, 4
			jmp	.no_data_influence
.clear:			mov	byte  [flag__atn_cleared], 0
.no_data_influence:	and	byte  bl, 0feh
			or	byte  al, bl
			mov	dword edi, (c64__1 + cia6526__c64_2)
			mov	byte  bl, al
			xor	byte  al, NOT8
			shl	byte  al, 5
			and	byte  al, 0c0h
			call	cia6526_signal_pra
			mov	byte  al, bl
			mov	dword edi, (vc1541__1 + via6522__vc1541_1)
			and	byte  al, 001h
			call	via6522_signal_ca1
			xor	byte  al, al
			test	byte  bl, 1
			jz	.no_atn
			or	byte  al, 080h
.no_atn:		test	byte  bl, 2
			jz	.no_clk
			or	byte  al, 004h
.no_clk:		test	byte  bl, 4
			jz	.no_data
			or	byte  al, 001h
.no_data:		call	via6522_signal_pb
			pop	dword esi
			pop	dword edi
			ret
;********************************************* karsten.scheibler@bigfoot.de *

