;****************************************************************************
;****************************************************************************
;*
;* sid6581.nasm
;*
;****************************************************************************
;****************************************************************************





%define SID6581_NASM
%include "sid6581.inc"
%include "c64link.inc"
%include "core.inc"
%include "audio.inc"
%include "print.inc"
%ifdef SID6581_LOG
%include "log.inc"
%endif



%define MODUL_ID	SID6581_MODUL_ID



;****************************************************************************
;* sid6581_initialize *******************************************************
;****************************************************************************
section .text
sid6581_initialize:
			ret



;****************************************************************************
;* sid6581_create_instance **************************************************
;****************************************************************************
section .text
sid6581_create_instance:
			push	dword eax
			mov	dword eax, [d__sid6581_global_id]
			mov	dword [MODUL_ID], eax
%ifdef SID6581_LOG
			call	log_open
%endif
			inc	dword eax
			mov	dword [d__sid6581_global_id], eax
			pop	dword eax
			ret

section .data
			align 4
d__sid6581_global_id:	dd	SID6581_GLOBAL_ID



;****************************************************************************
;* sid6581_destroy_instance *************************************************
;****************************************************************************
section .text
sid6581_destroy_instance:
%ifdef SID6581_LOG
			push	dword eax
			mov	dword eax, [MODUL_ID]
			call	log_close
			pop	dword eax
%endif
			ret



;****************************************************************************
;* sid6581_reset ************************************************************
;****************************************************************************
section .text
sid6581_reset:
			ret



;****************************************************************************
;* sid6581_dump *************************************************************
;****************************************************************************
section .text
sid6581_dump:
			cmp	dword eax, [MODUL_ID]
			jne	.end
			push	dword eax
			PRINT_TEXT  .cb__error, eax
			pop	dword eax
.end:			ret

.cb__error:		db	"-<SID6581:", STRING_INSERT_HEX32, ">-", 10
			db	"nothing to say here", 10, 0



;****************************************************************************
;* sid6581_read *************************************************************
;****************************************************************************
section .text
sid6581_read:
			ret



;****************************************************************************
;* sid6581_write ************************************************************
;****************************************************************************
section .text
sid6581_write:
			ret



;****************************************************************************
;* sid6581_cycle ************************************************************
;****************************************************************************
section .text
sid6581_cycle:
			ret
;********************************************* karsten.scheibler@bigfoot.de *

