;****************************************************************************
;****************************************************************************
;*
;* status.nasm
;*
;****************************************************************************
;****************************************************************************





%define STATUS_NASM
%include "status.inc"
%include "fb.inc"



;****************************************************************************
;* status_initialize ********************************************************
;****************************************************************************
section .text
status_initialize:
			ret



;****************************************************************************
;* status_vc1541_motor ******************************************************
;****************************************************************************
;* eax=>  Modul ID
;* bl==>  on/off
;****************************************************************************
section .text
status_vc1541_motor:
			push	dword eax
			push	dword ebx
			push	dword ecx
			or	byte  bl, bl
			mov	byte  al, 00fh
			jz	.off
			mov	byte  al, 00dh
.off:			mov	dword ebx, 100
			mov	dword ecx, 0
			call	fb_draw_led
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* status_vc1541_led ********************************************************
;****************************************************************************
;* eax=>  Modul ID
;* bl==>  on/off
;****************************************************************************
section .text
status_vc1541_led:
			push	dword eax
			push	dword ebx
			push	dword ecx
			or	byte  bl, bl
			mov	byte  al, 00fh
			jz	.off
			mov	byte  al, 00dh
.off:			mov	dword ebx, 108
			mov	dword ecx, 0
			call	fb_draw_led
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* status_vc1541_track ******************************************************
;****************************************************************************
;* eax=>  Modul ID
;* bl==>  track number
;****************************************************************************
section .text
status_vc1541_track:
			FB_DRAW_TEXT  100, 4, 0815, .cb__track_number, ebx
			ret

.cb__track_number:	db	STRING_INSERT_HEX8, 0



%ifdef STATUS_FRAME_PROFILING
%include "sync.inc"
;****************************************************************************
;* status_frame_time ********************************************************
;****************************************************************************
section .text
status_frame_time:
			push	dword eax
			call	sync_get_time
			FB_DRAW_TEXT  124, 4, 0815, .cb__frame_time, eax
			pop	dword eax
			ret

.cb__frame_time:	db	STRING_INSERT_HEX32, 0
%endif



;****************************************************************************
;* status_c64_decoded_lines *************************************************
;****************************************************************************
;* eax=>  Modul ID
;* ebx=>  number of lines
;****************************************************************************
section .text
status_c64_decoded_lines:
			FB_DRAW_TEXT  196, 4, 0815, .cb__decoded_lines, ebx
			ret

.cb__decoded_lines:	db	STRING_INSERT_HEX16, 0
;********************************************* karsten.scheibler@bigfoot.de *

