;****************************************************************************
;****************************************************************************
;*
;* vc1541link.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef VC1541LINK_INC
%define VC1541LINK_INC

%include "defines.inc"

%include "cpu65xx.inc"
%include "via6522.inc"
%include "disc.inc"
%include "vc1541memory.inc"



;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VC1541LINK_NASM
global vc1541link_initialize
global vc1541link_create_instance
global vc1541link_destroy_instance
global vc1541link_reset
global vc1541link_dump
global vc1541link_via_counter_set
global vc1541link_via_counter_refresh
global vc1541link_via_counter_clear
global vc1541link_via_counter_process
global vc1541link_via1_irq
global vc1541link_via1_pb
global vc1541link_via1_pa
global vc1541link_via1_cb2
global vc1541link_via1_ca2
global vc1541link_via2_irq
global vc1541link_via2_pb
global vc1541link_via2_pa
global vc1541link_via2_cb2
global vc1541link_via2_ca2
global vc1541link_disc_sync
global vc1541link_disc_data
global vc1541link_status
%else
extern vc1541link_initialize
extern vc1541link_create_instance
extern vc1541link_destroy_instance
extern vc1541link_reset
extern vc1541link_dump
extern vc1541link_via_counter_set
extern vc1541link_via_counter_refresh
extern vc1541link_via_counter_clear
extern vc1541link_via_counter_process
extern vc1541link_via1_irq
extern vc1541link_via1_pb
extern vc1541link_via1_pa
extern vc1541link_via1_cb2
extern vc1541link_via1_ca2
extern vc1541link_via2_irq
extern vc1541link_via2_pb
extern vc1541link_via2_pa
extern vc1541link_via2_cb2
extern vc1541link_via2_ca2
extern vc1541link_disc_sync
extern vc1541link_disc_data
extern vc1541link_status
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
%assign VC1541LINK_COUNTER_TABLE_ENTRIES	4

				struc vc1541link
				alignb 4
d__vc1541link_modul_id:		resd	1
d__vc1541link_counter_base:	resd	1
d__vc1541link_counter:		resd	1
ad__vc1541link_counter_table:	resd	(2 * VC1541LINK_COUNTER_TABLE_ENTRIES)
b__vc1541link_motor_state:	resb	1
b__vc1541link_led_state:	resb	1
b__vc1541link_track:		resb	1
b__vc1541link_serial_bus:	resb	1
				endstruc



				struc vc1541
				alignb 32
cpu65xx__vc1541:		resb	cpu65xx_size
				alignb 32
link__vc1541:			resb	vc1541link_size
				alignb 32
via6522__vc1541_1:		resb	via6522_size
				alignb 32
via6522__vc1541_2:		resb	via6522_size
				alignb 32
disc__vc1541:			resb	disc_size
				alignb 32
memory__vc1541:			resb	vc1541memory_size
				endstruc



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%assign VC1541LINK_COUNTER_DEFAULT_VALUE	010000000h

%define VC1541LINK_MODUL_ID		esi + link__vc1541 + d__vc1541link_modul_id
%define VC1541LINK_COUNTER_BASE		esi + link__vc1541 + d__vc1541link_counter_base
%define VC1541LINK_COUNTER		esi + link__vc1541 + d__vc1541link_counter
%define VC1541LINK_COUNTER_TABLE	esi + link__vc1541 + ad__vc1541link_counter_table
%define VC1541LINK_MOTOR_STATE		esi + link__vc1541 + b__vc1541link_motor_state
%define VC1541LINK_LED_STATE		esi + link__vc1541 + b__vc1541link_led_state
%define VC1541LINK_TRACK		esi + link__vc1541 + b__vc1541link_track
%define VC1541LINK_SERIAL_BUS		esi + link__vc1541 + b__vc1541link_serial_bus

%assign VC1541LINK_VIA1_COUNTER_OFFSET	000h
%assign VC1541LINK_VIA2_COUNTER_OFFSET	002h

%assign VC1541LINK_VIA1_IRQ_NUMBER	001h
%assign VC1541LINK_VIA2_IRQ_NUMBER	002h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VC1541LINK_CALL_CREATE_INSTANCE 0
			call	vc1541link_create_instance
%endmacro



%macro VC1541LINK_CALL_DESTROY_INSTANCE 0
			call	vc1541link_destroy_instance
%endmacro



%macro VC1541LINK_CALL_RESET 0
			call	vc1541link_reset
%endmacro



%macro VC1541LINK_CALL_DECREMENT_COUNTER 0
			dec	dword [VC1541LINK_COUNTER]
			jnz	%%no_call
			call	vc1541link_via_counter_process
%%no_call:
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

