;****************************************************************************
;****************************************************************************
;*
;* vc1541memory.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef VC1541MEMORY_INC
%define VC1541MEMORY_INC

%include "defines.inc"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VC1541MEMORY_NASM
global vc1541memory_initialize
global vc1541memory_create_instance
global vc1541memory_destroy_instance
global vc1541memory_reset
global vc1541memory_dump
global vc1541memory_read_opcode
global vc1541memory_read_stack
global vc1541memory_read_data
global vc1541memory_write_stack
global vc1541memory_write_data
%else
extern vc1541memory_initialize
extern vc1541memory_create_instance
extern vc1541memory_destroy_instance
extern vc1541memory_reset
extern vc1541memory_dump
extern vc1541memory_read_opcode
extern vc1541memory_read_stack
extern vc1541memory_read_data
extern vc1541memory_write_stack
extern vc1541memory_write_data
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
				struc vc1541memory
				alignb 4
d__vc1541memory_modul_id:	resd	1
d__vc1541memory_state:		resd	1
ab__vc1541memory_ram:		resb	00800h
				endstruc



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%define VC1541MEMORY_MODUL_ID		esi + memory__vc1541 + d__vc1541memory_modul_id
%define VC1541MEMORY_STATE		esi + memory__vc1541 + d__vc1541memory_state
%define VC1541MEMORY_RAM		esi + memory__vc1541 + ab__vc1541memory_ram
%define VC1541MEMORY_KERNEL_ROM		ab__vc1541_kernel_rom



%assign VC1541MEMORY_STACK_LIMIT_EXCEEDED		000000001h
%assign VC1541MEMORY_WORD_LIMIT_EXCEEDED		000000002h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VC1541MEMORY_CALL_CREATE_INSTANCE 0
			call	vc1541memory_create_instance
%endmacro



%macro VC1541MEMORY_CALL_RESET 0
			call	vc1541memory_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

