;****************************************************************************
;****************************************************************************
;*
;* vic6569.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef VIC6569_INC
%define VIC6569_INC

%include "defines.inc"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VIC6569_NASM
global vic6569_initialize
global vic6569_create_instance
global vic6569_destroy_instance
global vic6569_reset
global vic6569_dump
global vic6569_read
global vic6569_write
global vic6569_signal_high_bits
%else
extern vic6569_initialize
extern vic6569_create_instance
extern vic6569_destroy_instance
extern vic6569_reset
extern vic6569_dump
extern vic6569_read
extern vic6569_write
extern vic6569_signal_high_bits
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
%assign VIC6569_REGISTERS_SIZE		48
%assign VIC6569_LINES_PER_FRAME		312
%assign VIC6569_CHANGE_LOG_SIZE		20



					struc vicline
					alignb 4
ab__vicline_registers:			resb	VIC6569_REGISTERS_SIZE
ab__vicline_color_ram_cache:		resb	40
ab__vicline_video_cache:		resb	40
ab__vicline_data_cache:			resb	40
ad__vicline_change_log:			resd	VIC6569_CHANGE_LOG_SIZE
ab__vicline_sprite_cache:		resb	32
					endstruc



					struc vicdecode
					alignb 4
p__vicdecode_border:			resd	1
p__vicdecode_window:			resd	1
p__vicdecode_overscan:			resd	1
p__vicdecode_cycle_border:		resd	1
p__vicdecode_cycle_window:		resd	1
p__vicdecode_cycle_window_left:		resd	1
p__vicdecode_cycle_window_central:	resd	1
p__vicdecode_cycle_window_right1:	resd	1
p__vicdecode_cycle_window_right2:	resd	1
					endstruc



					struc vic6569
					alignb 4
d__vic6569_modul_id:			resd	1
d__vic6569_x_start:			resd	1
d__vic6569_x_end:			resd	1
d__vic6569_y_start:			resd	1
d__vic6569_y_end:			resd	1
d__vic6569_state:			resd	1
p__vic6569_execute_bus_cycle:		resd	1
b__vic6569_bus_cycle_counter:		resb	1
b__vic6569_dma_delay_counter:		resb	1
b__vic6569_sprite_dma_mask:		resb	1
b__vic6569_sprite_dma_mask_base:	resb	1
b__vic6569_sprite_y_expand_mask:	resb	1
					resb	3
d__vic6569_sprite_dma_cycles:		resd	1
d__vic6569_sprite_dma_cycles_base:	resd	1
d__vic6569_sprite_offset:		resd	1
ab__vic6569_sprite_counter:		resb	8
d__vic6569_video_address:		resd	1
d__vic6569_data_address:		resd	1
d__vic6569_video_counter:		resd	1
d__vic6569_row_counter:			resd	1
d__vic6569_cache_offset:		resd	1
d__vic6569_change_log_offset:		resd	1
d__vic6569_line_cycle:			resd	1
d__vic6569_line_counter:		resd	1
d__vic6569_line_latch:			resd	1
p__vic6569_last_line_address:		resd	1
p__vic6569_line_address:		resd	1
p__vic6569_next_line_address:		resd	1
d__vic6569_border_left:			resd	1
d__vic6569_border_right:		resd	1
d__vic6569_border_top:			resd	1
d__vic6569_border_buttom:		resd	1
d__vic6569_high_bits:			resd	1
p__vic6569_screen_start:		resd	1
p__vic6569_screen:			resd	1
d__vic6569_screen_line_length:		resd	1
vicdecode__vic6569_decode_functions:	resb	vicdecode_size
d__vic6569_decoded_lines:		resd	1
ab__vic6569_color_lookup_table:		resb	4
ab__vic6569_scroll_cache:		resb	16
ab__vic6569_registers:			resb	VIC6569_REGISTERS_SIZE
ab__vic6569_decode_registers:		resb	VIC6569_REGISTERS_SIZE
%ifdef VIC6569_ENABLE_4BPP
d__vic6569_plane_shift:			resd	1
ab__vic6569_plane_cache:		resb	00210h
%endif
avicline__vic6569_last_frame:		resb	(VIC6569_LINES_PER_FRAME + 1) * vicline_size
					endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%define VICLINE_REGISTERS		ab__vicline_registers
%define VICLINE_COLOR_RAM_CACHE		ab__vicline_color_ram_cache
%define VICLINE_VIDEO_CACHE		ab__vicline_video_cache
%define VICLINE_DATA_CACHE		ab__vicline_data_cache
%define VICLINE_CHANGE_LOG		ad__vicline_change_log
%define VICLINE_SPRITE_CACHE		ab__vicline_sprite_cache
%define VICLINE_SIZE			vicline_size

%define VICDECODE_BORDER		p__vicdecode_border
%define VICDECODE_WINDOW		p__vicdecode_window
%define VICDECODE_OVERSCAN		p__vicdecode_overscan
%define VICDECODE_CYCLE_BORDER		p__vicdecode_cycle_border
%define VICDECODE_CYCLE_WINDOW		p__vicdecode_cycle_window
%define VICDECODE_CYCLE_WINDOW_LEFT	p__vicdecode_cycle_window_left
%define VICDECODE_CYCLE_WINDOW_CENTRAL	p__vicdecode_cycle_window_central
%define VICDECODE_CYCLE_WINDOW_RIGHT1	p__vicdecode_cycle_window_right1
%define VICDECODE_CYCLE_WINDOW_RIGHT2	p__vicdecode_cycle_window_right2

%define	VIC6569_MODUL_ID		esi + vic6569__c64 + d__vic6569_modul_id
%define VIC6569_X_START			esi + vic6569__c64 + d__vic6569_x_start
%define VIC6569_X_END			esi + vic6569__c64 + d__vic6569_x_end
%define VIC6569_Y_START			esi + vic6569__c64 + d__vic6569_y_start
%define VIC6569_Y_END			esi + vic6569__c64 + d__vic6569_y_end
%define VIC6569_STATE			esi + vic6569__c64 + d__vic6569_state
%define VIC6569_EXECUTE_BUS_CYCLE	esi + vic6569__c64 + p__vic6569_execute_bus_cycle
%define VIC6569_BUS_CYCLE_COUNTER	esi + vic6569__c64 + b__vic6569_bus_cycle_counter
%define VIC6569_DMA_DELAY_COUNTER	esi + vic6569__c64 + b__vic6569_dma_delay_counter
%define VIC6569_SPRITE_DMA_MASK		esi + vic6569__c64 + b__vic6569_sprite_dma_mask
%define VIC6569_SPRITE_DMA_MASK_BASE	esi + vic6569__c64 + b__vic6569_sprite_dma_mask_base
%define VIC6569_SPRITE_Y_EXPAND_MASK	esi + vic6569__c64 + b__vic6569_sprite_y_expand_mask
%define VIC6569_SPRITE_DMA_CYCLES	esi + vic6569__c64 + d__vic6569_sprite_dma_cycles
%define VIC6569_SPRITE_DMA_CYCLES_BASE	esi + vic6569__c64 + d__vic6569_sprite_dma_cycles_base
%define VIC6569_SPRITE_OFFSET		esi + vic6569__c64 + d__vic6569_sprite_offset
%define VIC6569_SPRITE_COUNTER		esi + vic6569__c64 + ab__vic6569_sprite_counter
%define VIC6569_VIDEO_ADDRESS		esi + vic6569__c64 + d__vic6569_video_address
%define VIC6569_DATA_ADDRESS		esi + vic6569__c64 + d__vic6569_data_address
%define VIC6569_VIDEO_COUNTER		esi + vic6569__c64 + d__vic6569_video_counter
%define VIC6569_ROW_COUNTER		esi + vic6569__c64 + d__vic6569_row_counter
%define VIC6569_CACHE_OFFSET		esi + vic6569__c64 + d__vic6569_cache_offset
%define VIC6569_CHANGE_LOG_OFFSET	esi + vic6569__c64 + d__vic6569_change_log_offset
%define VIC6569_LINE_CYCLE		esi + vic6569__c64 + d__vic6569_line_cycle
%define VIC6569_LINE_COUNTER		esi + vic6569__c64 + d__vic6569_line_counter
%define VIC6569_LINE_LATCH		esi + vic6569__c64 + d__vic6569_line_latch
%define VIC6569_LAST_LINE_ADDRESS	esi + vic6569__c64 + p__vic6569_last_line_address
%define VIC6569_LINE_ADDRESS		esi + vic6569__c64 + p__vic6569_line_address
%define VIC6569_NEXT_LINE_ADDRESS	esi + vic6569__c64 + p__vic6569_next_line_address
%define	VIC6569_BORDER_LEFT		esi + vic6569__c64 + d__vic6569_border_left
%define VIC6569_BORDER_RIGHT		esi + vic6569__c64 + d__vic6569_border_right
%define VIC6569_BORDER_TOP		esi + vic6569__c64 + d__vic6569_border_top
%define VIC6569_BORDER_BUTTOM		esi + vic6569__c64 + d__vic6569_border_buttom
%define VIC6569_HIGH_BITS		esi + vic6569__c64 + d__vic6569_high_bits
%define VIC6569_SCREEN_START		esi + vic6569__c64 + p__vic6569_screen_start
%define VIC6569_SCREEN			esi + vic6569__c64 + p__vic6569_screen
%define VIC6569_SCREEN_LINE_LENGTH	esi + vic6569__c64 + d__vic6569_screen_line_length
%define VIC6569_DECODE_FUNCTIONS	esi + vic6569__c64 + vicdecode__vic6569_decode_functions
%define VIC6569_DECODED_LINES		esi + vic6569__c64 + d__vic6569_decoded_lines
%define VIC6569_COLOR_LOOKUP_TABLE	esi + vic6569__c64 + ab__vic6569_color_lookup_table
%define VIC6569_SCROLL_CACHE		esi + vic6569__c64 + ab__vic6569_scroll_cache
%define VIC6569_REGISTERS		esi + vic6569__c64 + ab__vic6569_registers
%define VIC6569_DECODE_REGISTERS	esi + vic6569__c64 + ab__vic6569_decode_registers
%ifdef VIC6569_ENABLE_4BPP
%define VIC6569_PLANE_SHIFT		esi + vic6569__c64 + d__vic6569_plane_shift
%define VIC6569_PLANE_CACHE		esi + vic6569__c64 + ab__vic6569_plane_cache
%endif
%define VIC6569_LAST_FRAME		esi + vic6569__c64 + avicline__vic6569_last_frame



%assign VIC6569_DATA_ADDRESS_IS_BITMAP		000000020h
%assign VIC6569_DATA_ADDRESS_IS_ECM		000000040h
%assign VIC6569_DISPLAY_DISABLE			000000100h
%assign VIC6569_DISPLAY_MODE			000000200h
%assign VIC6569_BAD_LINE			000000400h
%assign VIC6569_ACCESS_GRANTED			000000800h
%assign VIC6569_BORDER_MAIN			000001000h
%assign VIC6569_BORDER_VERTICAL			000002000h
%assign VIC6569_VIDEO_ADDRESS_IN_CHARACTER_ROM	000004000h
%assign VIC6569_DATA_ADDRESS_IN_CHARACTER_ROM	000008000h


;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VIC6569_CALL_CREATE_INSTANCE 0
			call	vic6569_create_instance
%endmacro



%macro VIC6569_CALL_DESTROY_INSTANCE 0
			call	vic6569_destroy_instance
%endmacro



%macro VIC6569_CALL_RESET 0
			call	vic6569_reset
%endmacro



%macro VIC6569_CALL_READ 0
			call	vic6569_read
%endmacro



%macro VIC6569_CALL_WRITE 0
			call	vic6569_write
%endmacro



%macro VIC6569_CALL_CYCLE 0
			call	dword [VIC6569_EXECUTE_BUS_CYCLE]
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

