;****************************************************************************
;****************************************************************************
;*
;* vic6569.nasm
;*
;****************************************************************************
;****************************************************************************





%define VIC6569_NASM
%include "vic6569.inc"
%include "core.inc"
%include "c64link.inc"
%include "sync.inc"
%include "fb.inc"
%include "print.inc"
%ifdef VIC6569_LOG
%include "log.inc"
%endif



%define	MODUL_ID		VIC6569_MODUL_ID
%define X_START			VIC6569_X_START
%define X_END			VIC6569_X_END
%define Y_START			VIC6569_Y_START
%define Y_END			VIC6569_Y_END
%define STATE			VIC6569_STATE
%define EXECUTE_BUS_CYCLE	VIC6569_EXECUTE_BUS_CYCLE
%define BUS_CYCLE_COUNTER	VIC6569_BUS_CYCLE_COUNTER
%define DMA_DELAY_COUNTER	VIC6569_DMA_DELAY_COUNTER
%define SPRITE_DMA_MASK		VIC6569_SPRITE_DMA_MASK
%define SPRITE_DMA_MASK_BASE	VIC6569_SPRITE_DMA_MASK_BASE
%define SPRITE_Y_EXPAND_MASK	VIC6569_SPRITE_Y_EXPAND_MASK
%define SPRITE_DMA_CYCLES	VIC6569_SPRITE_DMA_CYCLES
%define SPRITE_DMA_CYCLES_BASE	VIC6569_SPRITE_DMA_CYCLES_BASE
%define SPRITE_OFFSET		VIC6569_SPRITE_OFFSET
%define SPRITE_COUNTER		VIC6569_SPRITE_COUNTER
%define VIDEO_ADDRESS		VIC6569_VIDEO_ADDRESS
%define DATA_ADDRESS		VIC6569_DATA_ADDRESS
%define VIDEO_COUNTER		VIC6569_VIDEO_COUNTER
%define ROW_COUNTER		VIC6569_ROW_COUNTER
%define CACHE_OFFSET		VIC6569_CACHE_OFFSET
%define CHANGE_LOG_OFFSET	VIC6569_CHANGE_LOG_OFFSET
%define LINE_CYCLE		VIC6569_LINE_CYCLE
%define LINE_COUNTER		VIC6569_LINE_COUNTER
%define LINE_LATCH		VIC6569_LINE_LATCH
%define LAST_LINE_ADDRESS	VIC6569_LAST_LINE_ADDRESS
%define LINE_ADDRESS		VIC6569_LINE_ADDRESS
%define NEXT_LINE_ADDRESS	VIC6569_NEXT_LINE_ADDRESS
%define	BORDER_LEFT		VIC6569_BORDER_LEFT
%define BORDER_RIGHT		VIC6569_BORDER_RIGHT
%define BORDER_TOP		VIC6569_BORDER_TOP
%define BORDER_BUTTOM		VIC6569_BORDER_BUTTOM
%define HIGH_BITS		VIC6569_HIGH_BITS
%define SCREEN_START		VIC6569_SCREEN_START
%define SCREEN			VIC6569_SCREEN
%define SCREEN_LINE_LENGTH	VIC6569_SCREEN_LINE_LENGTH
%define DECODE_FUNCTIONS	VIC6569_DECODE_FUNCTIONS
%define DECODED_LINES		VIC6569_DECODED_LINES
%define COLOR_LOOKUP_TABLE	VIC6569_COLOR_LOOKUP_TABLE
%define SCROLL_CACHE		VIC6569_SCROLL_CACHE
%define REGISTERS		VIC6569_REGISTERS
%define DECODE_REGISTERS	VIC6569_DECODE_REGISTERS
%define PLANE_SHIFT		VIC6569_PLANE_SHIFT
%define PLANE_CACHE		VIC6569_PLANE_CACHE
%define LAST_FRAME		VIC6569_LAST_FRAME



%assign REGISTERS_SIZE		VIC6569_REGISTERS_SIZE
%assign LINES_PER_FRAME		VIC6569_LINES_PER_FRAME
%assign CHANGE_LOG_SIZE		VIC6569_CHANGE_LOG_SIZE



%assign DATA_ADDRESS_IS_BITMAP		VIC6569_DATA_ADDRESS_IS_BITMAP
%assign DATA_ADDRESS_IS_ECM		VIC6569_DATA_ADDRESS_IS_ECM
%assign DISPLAY_DISABLE			VIC6569_DISPLAY_DISABLE
%assign DISPLAY_MODE			VIC6569_DISPLAY_MODE
%assign BAD_LINE			VIC6569_BAD_LINE
%assign ACCESS_GRANTED			VIC6569_ACCESS_GRANTED
%assign BORDER_MAIN			VIC6569_BORDER_MAIN
%assign BORDER_VERTICAL			VIC6569_BORDER_VERTICAL
%assign VIDEO_ADDRESS_IN_CHARACTER_ROM	VIC6569_VIDEO_ADDRESS_IN_CHARACTER_ROM
%assign DATA_ADDRESS_IN_CHARACTER_ROM	VIC6569_DATA_ADDRESS_IN_CHARACTER_ROM



;****************************************************************************
;* vic6569_initialze ********************************************************
;****************************************************************************
section .text
vic6569_initialize:
			call	fb_clear
			call	fb_get_parameter
			mov	dword [d__x_resolution], eax
			mov	dword [d__x_padding], ebx
			mov	dword [d__y_resolution], ecx
			mov	dword [p__fb_address], edx
			mov	dword [d__fb_access_mode], ebp

			;----------------------------
			;generate decode_tables.hires
			;----------------------------

			xor	byte  al, al
			mov	dword ebp, decode_tables.hires
.text:			mov	byte  bl, al
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 4], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 1], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 5], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 2], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 6], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 3], cl
			shr	byte  bl, 1
			mov	byte  cl, bl
			and	byte  cl, 1
			mov	byte  [ebp + 7], cl
			add	dword ebp, 8
			inc	byte  al
			jnz	.text

			;--------------------------
			;generate decode_tables.mcm
			;--------------------------

			xor	byte  al, al
			mov	dword ebp, decode_tables.mcm
.mcm:			mov	byte  bl, al
			mov	byte  cl, bl
			and	byte  cl, 3
			mov	byte  [ebp], cl
			mov	byte  [ebp + 4], cl
			shr	byte  bl, 2
			mov	byte  cl, bl
			and	byte  cl, 3
			mov	byte  [ebp + 1], cl
			mov	byte  [ebp + 5], cl
			shr	byte  bl, 2
			mov	byte  cl, bl
			and	byte  cl, 3
			mov	byte  [ebp + 2], cl
			mov	byte  [ebp + 6], cl
			shr	byte  bl, 2
			mov	byte  cl, bl
			and	byte  cl, 3
			mov	byte  [ebp + 3], cl
			mov	byte  [ebp + 7], cl
			add	dword ebp, 8
			inc	byte  al
			jnz	.mcm

%ifdef VIC6569_ENABLE_4BPP
			xor	dword eax, eax
.make_transform_table:	test	byte  al, 008h
			setnz	byte  bh
			test	byte  al, 004h
			setnz	byte  bl
			shl	dword ebx, 16
			test	byte  al, 002h
			setnz	byte  bh
			test	byte  al, 001h
			setnz	byte  bl
			mov	dword [transform_table + 4 * eax], ebx
			inc	byte  al
			cmp	byte  al, 16
			jb	.make_transform_table
%endif
			ret

section .bss
			alignb 4
d__x_resolution:	resd	1
d__x_padding:		resd	1
d__y_resolution:	resd	1
p__fb_address:		resd	1
d__fb_access_mode:	resd	1
decode_tables:		
.hires:			resb	00800h
.mcm:			resb	00800h
%ifdef VIC6569_ENABLE_4BPP
transform_table:	resb	040h
%endif



;****************************************************************************
;* vic6569_create_instance **************************************************
;****************************************************************************
section .text
vic6569_create_instance:
			push	dword eax
			mov	dword eax, [d__vic6569_global_id]
			mov	dword [MODUL_ID], eax
%ifdef VIC6569_LOG
			call	log_open
%endif
			inc	dword eax
			mov	dword [d__vic6569_global_id], eax
			pop	dword eax
			ret

section .data
			align 4
d__vic6569_global_id:	dd	VIC6569_GLOBAL_ID



;****************************************************************************
;* vic6569_destroy_instance *************************************************
;****************************************************************************
section .text
vic6569_destroy_instance:
%ifdef VIC6569_LOG
			push	dword eax
			mov	dword eax, [MODUL_ID]
			call	log_close
			pop	dword eax
%endif
			ret



%ifdef VIC6569_LOG
;****************************************************************************
;* vic6569_log **************************************************************
;****************************************************************************
;* <=eax  data length
;* <=ebx  pointer to data
;****************************************************************************
section .text
vic6569_log:
			push	dword ecx
			push	dword edx
			mov	dword ecx, [LINE_COUNTER]
			mov	dword edx, [LINE_CYCLE]
			mov	word  [.ab__status + 8], bx
			mov	word  [.ab__status + 10], cx
			mov	byte  bl, [REGISTERS + 015h]
			mov	byte  [.ab__status + 12], dl
			mov	byte  [.ab__status + 13], al
			mov	byte  [.ab__status + 14], bl
			call	core_get_c64_cycles
			mov	dword [.ab__status], eax
			mov	dword ebx, [STATE]
			mov	dword [.ab__status + 4], ebx
			pop	dword edx
			pop	dword ecx
			mov	dword eax, 16
			mov	dword ebx, .ab__status
			ret

section .data
			align 4
.ab__status:		times 16 db 0
%endif



;****************************************************************************
;* vic6569_reset ************************************************************
;****************************************************************************
section .text
vic6569_reset:
			;------------------------------------------
			;clear the whole VIC data structure, except
			;MODUL_ID ==> the first dword in the
			;structure
			;------------------------------------------

			xor	dword eax, eax
			mov	dword ecx, ((vic6569_size - 4)/ 4)
			lea	dword edi, [MODUL_ID + 4]
			rep stosd

			;----------------------------------------
			;set the start end end of the screen area
			;----------------------------------------

			mov	dword eax, 10
			mov	dword ebx, 60
			mov	dword ecx, 20
			mov	dword edx, 280
			mov	dword [X_START], eax
			mov	dword [X_END], ebx
			mov	dword [Y_START], ecx
			mov	dword [Y_END], edx

			call	vic6569_screen_initialize

			;---------------------------------
			;initialize values, which are != 0
			;---------------------------------

			mov	dword [STATE], (BORDER_MAIN | BORDER_VERTICAL)
			mov	dword [LINE_ADDRESS], VICLINE_SIZE
			mov	dword [NEXT_LINE_ADDRESS], (2 * VICLINE_SIZE)
			mov	dword [EXECUTE_BUS_CYCLE], bus_cycle_0_new_frame

			mov	dword eax, 51
			mov	dword ebx, 251
			mov	dword ecx, 15
			mov	dword edx, 56		;55 + 1
			mov	dword [BORDER_TOP], eax
			mov	dword [BORDER_BUTTOM], ebx
			mov	dword [BORDER_LEFT], ecx
			mov	dword [BORDER_RIGHT], edx

			xor	dword ebx, ebx
			xor	dword eax, eax
			mov	byte  bl, (REGISTERS_SIZE - 1)
.clear_registers:	call	vic6569_write
			dec	dword ebx
			jns	.clear_registers
			ret



;****************************************************************************
;* vic6569_dump *************************************************************
;****************************************************************************
;* eax=>  Modul ID
;****************************************************************************
section .text
vic6569_dump:
			cmp	dword eax, [MODUL_ID]
			jne	.end
			PRINT_TEXT  .cb__error, eax, [STATE]
.end:			ret

.cb__error:		db	"-<VIC6569:", STRING_INSERT_HEX32, ">-", 10
			db	"State: ", STRING_INSERT_HEX32, 10, 0





;****************************************************************************
;****************************************************************************
;*
;* PART ?.?: Read/Write Functions
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* CHECK_ADDRESS ************************************************************
;****************************************************************************
%macro CHECK_ADDRESS 2
			test	dword eax, 06000h
			jnz	%%no_character_rom
			test	dword eax, 01000h
			jz	%%no_character_rom
			or	dword %1, %2
%%no_character_rom:
%endmacro



;****************************************************************************
;* change_log_write *********************************************************
;****************************************************************************
section .text
change_log_write:
			cmp	byte  [REGISTERS + ebp], al
			je	.register_unchanged
			push	dword ebx
			push	dword ecx
			push	dword ebp
			mov	dword ebx, [CHANGE_LOG_OFFSET]
			mov	dword ecx, ebp
			mov	dword ebp, [LINE_ADDRESS]
			shl	dword ecx, 16
			inc	dword ebx
			mov	byte  ch, al
			mov	dword [CHANGE_LOG_OFFSET], ebx
			lea	dword ebp, [VICLINE_CHANGE_LOG + ebp + 4 * ebx - 4]
			mov	byte  cl, [LINE_CYCLE]
			mov	dword [LAST_FRAME + ebp], ecx
			pop	dword ebp
			pop	dword ecx
			pop	dword ebx
.register_unchanged:	ret



;****************************************************************************
;* vic6569_read *************************************************************
;****************************************************************************
section .text
vic6569_read:
%ifdef VIC6569_LOG
%ifdef VIC6569_LOG_EVERY_READ
			push	dword eax
			push	dword edx
			call	core_get_c64_cycles
			cmp	dword eax, 021220000h
			jb	.skip_log
			cmp	dword eax, 021400000h
			ja	.skip_log
			push	dword ebx
			push	dword ecx
			mov	byte  al, 0ffh
			call	vic6569_log
			mov	dword ecx, eax
			mov	dword eax, [MODUL_ID]
			call	log_write
			pop	dword ecx
			pop	dword ebx
.skip_log:		pop	dword edx
			pop	dword eax
%endif
%endif
			mov	dword ebp, ebx
			and	dword ebp, 03fh
			cmp	dword ebp, 02eh
			ja	.read_rubbish
			xor	byte  ah, ah
			mov	byte  al, [REGISTERS + ebp]
			cmp	dword ebp, 01eh
			jne	.read_1
			mov	byte  [REGISTERS + ebp], ah
			ret
.read_1:		cmp	dword ebp, 01fh
			jne	.read_2
			mov	byte  [REGISTERS + ebp], ah
.read_2:		ret
.read_rubbish:		mov	byte  al, 0ffh
			ret



;****************************************************************************
;* vic6569_write ************************************************************
;****************************************************************************
section .text
vic6569_write:
%ifdef VIC6569_LOG
%ifdef VIC6569_LOG_EVERY_WRITE
			push	dword eax
			push	dword edx
			call	core_get_c64_cycles
			cmp	dword eax, 02d00000h
			jb	.skip_log
			cmp	dword eax, 03d00000h
			ja	.skip_log
			mov	dword eax, [esp + 4]
			push	dword ebx
			push	dword ecx
			call	vic6569_log
			mov	dword ecx, eax
			mov	dword eax, [MODUL_ID]
			call	log_write
			pop	dword ecx
			pop	dword ebx
.skip_log:		pop	dword edx
			pop	dword eax
%endif
%endif
			mov	dword ebp, ebx
			and	dword ebp, 03fh
			jmp	dword [.ap__registers + 4 * ebp]

.ap__registers:		dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position
			dd	write_sprite_position

			dd	write_sprite_position
			dd	write_register_11
			dd	write_register_12
			dd	write_ignore
			dd	write_ignore
			dd	write_register_15
			dd	write_register_16
			dd	write_register_17
			dd	write_register_18
			dd	write_register_19
			dd	write_register_1a
			dd	write_register_1b
			dd	write_register_1c
			dd	write_register_1d
			dd	write_register_1e
			dd	write_register_1f

			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_color
			dd	write_sprite_mcm
			dd	write_sprite_mcm
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_sprite_color
			dd	write_ignore

			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore
			dd	write_ignore

write_ignore:
			ret

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;should i call change_log_write for sprite positions ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
write_sprite_position:
			mov	byte  [REGISTERS + ebp], al
			ret

write_register_11:
			mov	byte  ah, al
			push	dword ebx
			and	byte  al, 07fh
			call	change_log_write
			mov	byte  bl, [REGISTERS + 011h]
			rol	byte  ah, 1
			and	byte  bl, 080h
			and	byte  ah, 001h
			or	byte  al, bl
			mov	byte  [REGISTERS + 011h], al
			mov	byte  [STATE], al
			mov	byte  [LINE_LATCH + 1], ah
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;extra IRQ Handling like write_register_12 ???
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword ebx, 55
			mov	dword eax, [STATE]
			mov	dword ebp, 247
			test	byte  al, 008h
			jz	.text_lines_24
			mov	dword ebx, 51
			mov	dword ebp, 251
.text_lines_24:		mov	dword [BORDER_TOP], ebx
			mov	dword [BORDER_BUTTOM], ebp
			mov	byte  bl, [REGISTERS + 018h]
			mov	dword ebp, [LINE_COUNTER]
			shl	dword ebx, 10
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;DMA should stay enabled, if it was enabled before disabling in line 48
;result should be a disabled screen but DMA enabled ==> VIC-Article
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			cmp	dword ebp, 48
			ja	.end
			and	dword eax, (NOT32 - DISPLAY_DISABLE)
			test	byte  al, 010h
			jnz	.end
			or	dword eax, DISPLAY_DISABLE
.end:			and	dword ebx, 03800h
			mov	dword ebp, eax
			test	dword eax, DATA_ADDRESS_IS_BITMAP
			jz	.no_bitmap
			and	dword ebx, 02000h
.no_bitmap:		mov	dword eax, [HIGH_BITS]
			or	dword eax, ebx
			CHECK_ADDRESS  ebp, DATA_ADDRESS_IN_CHARACTER_ROM
			mov	dword [DATA_ADDRESS], eax
			mov	dword [STATE], ebp
			pop	dword ebx
			ret

write_register_12:
			mov	byte  [LINE_LATCH], al
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;is this extra IRQ Handling correct ???
;turrican-side1.d64 likes it ;-)
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			push	dword ebx
			mov	dword eax, [LINE_COUNTER]
			mov	byte  bl, [REGISTERS + 019h]
			cmp	dword eax, [LINE_LATCH]
			jne	.line_latch_differs
			mov	byte  al, [REGISTERS + 01ah]
			or	byte  bl, 001h
			test	byte  al, 001h
			jz	.no_irq
			or	byte  bl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	byte  [REGISTERS + 019h], bl
.line_latch_differs:	pop	dword ebx
			ret

write_register_15:
			call	change_log_write
			mov	byte  [REGISTERS + 015h], al
			ret

write_register_16:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: state of the reset bit ?
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			or	byte  al, 0c0h
			call	change_log_write
			push	dword ebx
			mov	byte  [REGISTERS + 016h], al
			mov	dword ebx, 16
			mov	dword ebp, 55		;54 + 1
			test	byte  al, 008h
			jz	.text_rows_38
			mov	dword ebx, 15
			mov	dword ebp, 56		;55 + 1
.text_rows_38:		mov	dword [BORDER_LEFT], ebx
			mov	dword [BORDER_RIGHT], ebp
			pop	dword ebx
			ret

write_register_17:
			mov	byte  [REGISTERS + 017h], al
			xor	byte  al, NOT8
			mov	byte  [SPRITE_Y_EXPAND_MASK], al
			ret

write_register_18:
			or	byte  al, 001h
			call	change_log_write
			mov	byte  [REGISTERS + 018h], al
			push	dword ebx
			push	dword ecx
			mov	byte  bl, al
			shl	dword eax, 6
			mov	dword ecx, [STATE]
			shl	dword ebx, 10
			and	dword eax, 03c00h
			and	dword ebx, 03800h
			or	dword eax, [HIGH_BITS]
			and	dword ecx, (NOT32 - VIDEO_ADDRESS_IN_CHARACTER_ROM - DATA_ADDRESS_IN_CHARACTER_ROM)
			CHECK_ADDRESS  ecx, VIDEO_ADDRESS_IN_CHARACTER_ROM
			mov	dword [VIDEO_ADDRESS], eax
			test	dword ecx, DATA_ADDRESS_IS_BITMAP
			mov	dword eax, [HIGH_BITS]
			jz	.no_bitmap
			and	dword ebx, 02000h
.no_bitmap:		or	dword eax, ebx
			CHECK_ADDRESS  ecx, DATA_ADDRESS_IN_CHARACTER_ROM
			mov	dword [DATA_ADDRESS], eax
			mov	dword [STATE], ecx
			pop	dword ecx
			pop	dword ebx
			ret


write_register_19:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;TODO: correct behavior of this register
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;			and	byte  al, 00fh
;			or	byte  al, 070h
;			mov	byte  [REGISTERS + 019h], al
			xor	byte  al, al
			mov	byte  [REGISTERS + 019h], al
			call	c64link_vic_irq
			ret

write_register_1a:
			or	byte  al, 0f0h
			mov	byte  [REGISTERS + 01ah], al
			ret

write_register_1b:
			ret

write_register_1c:
			ret

write_register_1d:
			mov	byte  [REGISTERS + 01dh], al
			ret

write_register_1e:
			ret

write_register_1f:
			ret

write_color:
			or	byte  al, 0f0h
			call	change_log_write
			mov	byte  [REGISTERS + ebp], al
			ret

write_sprite_mcm:
			ret

write_sprite_color:
;			or	byte  al, 0f0h
;			call	change_log_write
;			mov	byte  [REGISTERS + ebp], al
			ret





;****************************************************************************
;****************************************************************************
;*
;* PART ?.?: Bus Cycle Functions
;*
;****************************************************************************
;****************************************************************************





%ifdef VIC6569_DISABLE_NEW_BUS_CYCLE_15
;****************************************************************************
;* BUS_CYCLE_READ_RAM *******************************************************
;****************************************************************************
%macro BUS_CYCLE_READ_RAM 1
			mov	byte  %1, [C64MEMORY_RAM + ebx]
			test	dword ebx, 06000h
			jnz	%%no_character_rom
			test	dword ebx, 01000h
			jz	%%no_character_rom
			and	dword ebx, 00fffh
			mov	byte  %1, [C64MEMORY_CHARACTER_ROM + ebx]
%%no_character_rom:
%endmacro
%endif



;****************************************************************************
;* BUS_CYCLE_VIDEO_READ_BAD_LINE ********************************************
;****************************************************************************
;* eax=>  STATE
;* ebx=>  VIDEO_COUNTER
;* ebp=>  LINE_ADDRESS + CACHE_OFFSET
;* <=eax  STATE
;* <=ebx  VIDEO_COUNTER
;* <=ebp  LINE_ADDRESS + CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_VIDEO_READ_BAD_LINE 0
			mov	byte  cl, [C64MEMORY_COLOR_RAM + ebx]
			or	dword ebx, [VIDEO_ADDRESS]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], cl
			test	dword eax, VIDEO_ADDRESS_IN_CHARACTER_ROM
			mov	byte  dl, [C64MEMORY_RAM + ebx]
			jz	%%no_character_rom
			and	dword ebx, 00fffh
			mov	byte  dl, [C64MEMORY_CHARACTER_ROM + ebx]
%%no_character_rom:	mov	dword ebx, [VIDEO_COUNTER]
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
%endmacro



;****************************************************************************
;* BUS_CYCLE_VIDEO_READ *****************************************************
;****************************************************************************
;* eax=>  STATE
;* ebx=>  VIDEO_COUNTER
;* ecx=>  LAST_LINE_ADDRESS + CACHE_OFFSET
;* ebp=>  LINE_ADDRESS + CACHE_OFFSET
;* <=eax  STATE
;* <=ebx  VIDEO_COUNTER
;* <=ebp  LINE_ADDRESS + CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_VIDEO_READ 0
			mov	byte  dl, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ecx]
			mov	byte  cl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ecx]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], cl
%endmacro



;****************************************************************************
;* BUS_CYCLE_DATA_READ ******************************************************
;****************************************************************************
;* eax=>  STATE
;* ebx=>  VIDEO_COUNTER
;* ebp=>  LINE_ADDRESS + CACHE_OFFSET
;* <=eax  STATE
;* <=edx  CACHE_OFFSET + 1
;* <=ebp  LINE_ADDRESS + CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_DATA_READ 0
			test	dword eax, DATA_ADDRESS_IS_BITMAP
			jnz	%%bitmap
			xor	dword ebx, ebx
			mov	byte  bl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
%%bitmap:		mov	dword ecx, [VIDEO_COUNTER]
			shl	dword ebx, 3
			inc	dword ecx
			or	dword ebx, [ROW_COUNTER]
			mov	dword [VIDEO_COUNTER], ecx
			or	dword ebx, [DATA_ADDRESS]
			mov	dword edx, [CACHE_OFFSET]
			test	dword eax, DATA_ADDRESS_IS_ECM
			jz	%%no_ecm
			and	byte  bh, 0f9h
%%no_ecm:		inc	dword edx
			test	dword eax, DATA_ADDRESS_IN_CHARACTER_ROM
			mov	byte  cl, [C64MEMORY_RAM + ebx]
			jz	%%no_character_rom
			and	dword ebx, 00fffh
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + ebx]
%%no_character_rom:	mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], cl
%endmacro



;****************************************************************************
;* BUS_CYCLE_IDLE_READ ******************************************************
;****************************************************************************
;* eax=>  STATE
;* ebp=>  LINE_ADDRESS + CACHE_OFFSET
;* <=eax  STATE
;* <=edx  CACHE_OFFSET + 1
;* <=ebp  LINE_ADDRESS + CACHE_OFFSET
;****************************************************************************
%macro BUS_CYCLE_IDLE_READ 0
			mov	dword ebx, [HIGH_BITS]
			mov	dword edx, [CACHE_OFFSET]
			or	dword ebx, 03fffh
			test	dword eax, DATA_ADDRESS_IS_ECM
			jz	%%no_ecm
			and	byte  bh, 0f9h
%%no_ecm:		inc	dword edx
			mov	byte  cl, [C64MEMORY_RAM + ebx]
			xor	byte  bl, bl
			mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], cl
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], bl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], bl
%endmacro



;****************************************************************************
;* BUS_CYCLE_SPRITE_READ ****************************************************
;****************************************************************************
%macro BUS_CYCLE_SPRITE_READ 0
			mov	dword ebp, [SPRITE_OFFSET]
			xor	dword ecx, ecx
			mov	dword ebx, ebp
			shl	dword ebp, 2
			mov	byte  al, [SPRITE_DMA_MASK]
			add	dword ebp, [LINE_ADDRESS]
			shr	byte  al, 1
			mov	byte  [SPRITE_DMA_MASK], al
			jnc	%%sprite_off
			call	bus_cycle_sprite_read
;!!!!!!!!!!!!!!!!!!!!!!!!!!
;only for temporary testing
;			mov	dword edx, [LINE_ADDRESS]
;			lea	dword edx, [edx + 4 * ebx]
;			mov	dword [LAST_FRAME + VICLINE_DATA_CACHE + edx], ecx
;!!!!!!!!!!!!!!!!!!!!!!!!!!
%%sprite_off:		inc	dword ebx
			mov	dword [LAST_FRAME + VICLINE_SPRITE_CACHE + ebp], ecx
			mov	dword [SPRITE_OFFSET], ebx
%endmacro



;****************************************************************************
;* bus_cycle_sprite_read ****************************************************
;****************************************************************************
section .text
bus_cycle_sprite_read:
			mov	byte  al, [REGISTERS + 018h]
			or	dword ebx, 003f8h
			shl	dword eax, 6
			or	dword ebx, [HIGH_BITS]
			and	dword eax, 03c00h
			xor	dword edx, edx
			or	dword eax, ebx
			mov	byte  dl, [C64MEMORY_RAM + eax]
			test	dword eax, 06000h
			jnz	.no_character_rom_1
			test	dword eax, 01000h
			jz	.no_character_rom_1
			and	dword eax, 00fffh
			mov	byte  dl, [C64MEMORY_CHARACTER_ROM + eax]
.no_character_rom_1:	mov	dword ebx, [SPRITE_OFFSET]
			shl	dword edx, 6
			mov	dword eax, [HIGH_BITS]
			or	byte  dl, [SPRITE_COUNTER + ebx]
			xor	dword ecx, ecx
			or	dword eax, edx
			test	dword eax, 06000h
			jnz	.no_character_rom_2
			test	dword eax, 01000h
			jz	.no_character_rom_2
			and	dword eax, 00fffh
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;i might get an overflow if i address like this, because i
;have to test if SPRITE_COUNTER == 63, with some nasty raster manipulation
;this condition can be disabled ==> i cross the 64 byte boundary
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + eax]
			shl	dword ecx, 16
			mov	byte  ch, [C64MEMORY_CHARACTER_ROM + eax + 1]
			mov	byte  cl, [C64MEMORY_CHARACTER_ROM + eax + 2]
			ret
.no_character_rom_2:	mov	byte  cl, [C64MEMORY_RAM + eax]
			shl	dword ecx, 16
			mov	byte  ch, [C64MEMORY_RAM + eax + 1]
			mov	byte  cl, [C64MEMORY_RAM + eax + 2]
			ret


;****************************************************************************
;* BUS_CYCLE_CHECK_BORDER_LEFT **********************************************
;****************************************************************************
;* eax=>  STATE
;* ecx=>  LINE_CYCLE
;* <=eax  STATE
;* <=ecx  LINE_CYCLE
;****************************************************************************
%macro BUS_CYCLE_CHECK_BORDER_LEFT 0
			mov	dword edx, [LINE_COUNTER]
			cmp	dword ecx, [BORDER_LEFT]
			jne	%%border_left
			cmp	dword edx, [BORDER_BUTTOM]
			jne	%%border_buttom
			or	dword eax, BORDER_VERTICAL
%%border_buttom:	cmp	dword edx, [BORDER_TOP]
			jne	%%border_top
			test	dword eax, DISPLAY_DISABLE
			jnz	%%border_top
			and	dword eax, (NOT32 - BORDER_VERTICAL)
%%border_top:		test	dword eax, BORDER_VERTICAL
			jnz	%%border_left
			and	dword eax, (NOT32 - BORDER_MAIN)
%%border_left:
%endmacro



;****************************************************************************
;* BUS_CYCLE_CHECK_BORDER_RIGHT *********************************************
;****************************************************************************
;* eax=>  STATE
;* ecx=>  LINE_CYCLE + 1
;* <=eax  STATE
;* <=ecx  LINE_CYCLE + 1
;****************************************************************************
%macro BUS_CYCLE_CHECK_BORDER_RIGHT 0
			cmp	dword ecx, [BORDER_RIGHT]
			jne	%%border_right
			or	dword eax, BORDER_MAIN
%%border_right:
%endmacro



;****************************************************************************
;* BUS_CYCLE_SPRITE_COUNTER_ADD *********************************************
;****************************************************************************
%macro BUS_CYCLE_SPRITE_COUNTER_ADD 1
%ifnidn %1, 1
%ifnidn %1, 2
%error "BUS_CYCLE_SPRITE_COUNTER_ADD: only 1 or 2 allowed!"
%endif
%endif
%ifidn %1, 1
			xor	byte  ch, ch
%endif
			mov	byte  cl, [SPRITE_Y_EXPAND_MASK]
			xor	dword ebx, ebx
%%loop:			shr	byte  cl, 1
			setc	byte  al
%ifidn %1, 2
			shl	byte  al, 1
%endif
			add	byte  al, [SPRITE_COUNTER + ebx]
%ifidn %1, 1
			cmp	byte  al, 03fh
			setne	byte  ah
			or	byte  ch, ah
			ror	byte  ch, 1
%endif
			and	byte  al, 03fh
			mov	byte  [SPRITE_COUNTER + ebx], al
			inc	dword ebx
			cmp	byte  bl, 8
			jb	%%loop
%ifidn %1, 1
			mov	byte  al, [SPRITE_DMA_MASK_BASE]
			and	byte  al, ch
			cmp	byte  al, [SPRITE_DMA_MASK_BASE]
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma.cycles
%%skip_calculation:
%endif
%endmacro



%ifndef VIC6569_DISABLE_NEW_BUS_CYCLE_15
;****************************************************************************
;* BUS_CYCLE_CHECK_BAD_LINE *************************************************
;****************************************************************************
%macro BUS_CYCLE_CHECK_BAD_LINE 1
%ifnidn %1, [STATE]
%ifnidn %1, eax
%error "BUS_CYCLE_CHECK_BAD_LINE: only [STATE] or eax allowed!"
%endif
%endif
			test	dword %1, (DISPLAY_DISABLE | BAD_LINE)
			jnz	%%bad_line
			mov	dword ecx, [LINE_COUNTER]
			mov	byte  dl, [REGISTERS + 011h]
			and	byte  cl, 007h
			and	byte  dl, 007h
			cmp	byte  cl, dl
			jne	%%end
%ifnidn %1, eax
			mov	dword eax, [STATE]
%endif
			mov	byte  cl, 4
			or	dword eax, (VIC6569_BAD_LINE | VIC6569_DISPLAY_MODE)
			mov	byte  [DMA_DELAY_COUNTER], cl
%ifnidn %1, eax
			mov	dword [STATE], eax
%endif
			call	cpu65xx_signal_set_dma
%%bad_line:		cmp	byte  [DMA_DELAY_COUNTER], 0
			je	%%end
			dec	byte  [DMA_DELAY_COUNTER]
			jnz	%%end
%ifidn %1, eax
			or	dword eax, ACCESS_GRANTED
%else
			or	dword [STATE], ACCESS_GRANTED
%endif
%%end:
%endmacro



%else
;****************************************************************************
;* BUS_CYCLE_CHECK_BAD_LINE *************************************************
;****************************************************************************
%macro BUS_CYCLE_CHECK_BAD_LINE 1
%ifnidn %1, [STATE]
%ifnidn %1, eax
%error "BUS_CYCLE_CHECK_BAD_LINE: only [STATE] or eax allowed!"
%endif
%endif
			test	dword %1, (DISPLAY_DISABLE | BAD_LINE)
			jnz	%%bad_line
			mov	dword ecx, [LINE_COUNTER]
			mov	byte  dl, [REGISTERS + 011h]
			and	byte  cl, 007h
			and	byte  dl, 007h
			cmp	byte  cl, dl
			jne	%%end
;!!!!!!!!!!!!!!!!!!!!!!!
;should be removed later
			cmp	dword [LINE_CYCLE], 54
			je	%%end
;!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword eax, [STATE]
			mov	byte  cl, 4
			or	dword eax, (VIC6569_BAD_LINE | VIC6569_DISPLAY_MODE)
			mov	byte  [DMA_DELAY_COUNTER], cl
			mov	dword [STATE], eax
			call	cpu65xx_signal_set_dma
%%bad_line:		cmp	byte  [DMA_DELAY_COUNTER], 0
			je	%%end
			dec	byte  [DMA_DELAY_COUNTER]
			jnz	%%end
			or	dword [STATE], ACCESS_GRANTED
%%end:
%endmacro
%endif



;****************************************************************************
;* BUS_CYCLE_CHECK_SPRITE_DMA ***********************************************
;****************************************************************************
%macro BUS_CYCLE_CHECK_SPRITE_DMA 1
%ifnidn %1, jmp
%ifnidn %1, call
%error "BUS_CYCLE_CHECK_SPRITE_DMA: only jmp or call allowed!"
%endif
%endif
			mov	dword eax, cpu65xx_signal_clear_dma
			shr	dword [SPRITE_DMA_CYCLES], 1
			jnc	%%dma_off
			mov	dword eax, cpu65xx_signal_set_dma
%%dma_off:		%1	dword eax
%endmacro



;****************************************************************************
;* BUS_CYCLE_CALCULATE_SPRITE_DMA1 ******************************************
;****************************************************************************
%macro BUS_CYCLE_CALCULATE_SPRITE_DMA1 0
			mov	byte  al, [SPRITE_DMA_MASK_BASE]
			mov	byte  bl, [LINE_COUNTER]
			cmp	byte  al, 0ffh
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma
%%skip_calculation:	
%endmacro



;****************************************************************************
;* BUS_CYCLE_CALCULATE_SPRITE_DMA2 ******************************************
;****************************************************************************
%macro BUS_CYCLE_CALCULATE_SPRITE_DMA2 0
			mov	dword ebp, [SPRITE_DMA_CYCLES_BASE]
			mov	byte  al, [SPRITE_DMA_MASK_BASE]
			mov	byte  bl, [LINE_COUNTER]
			cmp	byte  al, 0ffh
			je	%%skip_calculation
			call	bus_cycle_calculate_sprite_dma
%%skip_calculation:	xor	dword ebx, ebx
			mov	byte  [SPRITE_DMA_MASK], al
			mov	dword [SPRITE_OFFSET], ebx
			mov	dword [SPRITE_DMA_CYCLES], ebp
%endmacro



;****************************************************************************
;* bus_cycle_calculate_sprite_dma *******************************************
;****************************************************************************
section .text
bus_cycle_calculate_sprite_dma:
			;---------------------------------------------------
			;if sprite position y == low 8 bit from LINE_COUNTER
			;and the sprite enabled then switch DMA on
			;---------------------------------------------------

			cmp	byte  bl, [REGISTERS + 00fh]
			sete	byte  cl
			cmp	byte  bl, [REGISTERS + 00dh]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 00bh]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 009h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 007h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 005h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 003h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			cmp	byte  bl, [REGISTERS + 001h]
			sete	byte  dl
			shl	byte  cl, 1
			or	byte  cl, dl
			and	byte  cl, [REGISTERS + 015h]
			or	byte  al, cl
			cmp	byte  al, [SPRITE_DMA_MASK_BASE]
			je	.end

			;-------------------------------------------
			;clear SPRITE_COUNTER only for those sprites
			;with LINE_COUNTER == sprite position y
			;-------------------------------------------

			xor	dword ebx, ebx
.loop:			shr	byte  cl, 1
			jnc	.no_clear
			mov	byte  [SPRITE_COUNTER + ebx], bh
.no_clear:		inc	dword ebx
			cmp	byte  bl, 8
			jb	.loop

			;-----------------------------------
			;mark the cycles which block the cpu
			;-----------------------------------

.cycles:		mov	byte  [SPRITE_DMA_MASK_BASE], al
			xor	dword ebx, ebx
			xor	dword ebp, ebp
			mov	byte  bl, 01fh
			shr	byte  al, 1
			jnc	.sprite0_dma_off
			or	dword ebp, ebx
.sprite0_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite1_dma_off
			or	dword ebp, ebx
.sprite1_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite2_dma_off
			or	dword ebp, ebx
.sprite2_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite3_dma_off
			or	dword ebp, ebx
.sprite3_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite4_dma_off
			or	dword ebp, ebx
.sprite4_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite5_dma_off
			or	dword ebp, ebx
.sprite5_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite6_dma_off
			or	dword ebp, ebx
.sprite6_dma_off:	shl	dword ebx, 2
			shr	byte  al, 1
			jnc	.sprite7_dma_off
			or	dword ebp, ebx
.sprite7_dma_off:	mov	byte  al, [SPRITE_DMA_MASK_BASE]
			mov	dword [SPRITE_DMA_CYCLES_BASE], ebp
.end:			ret



;****************************************************************************
;* bus_cycle_0 **************************************************************
;****************************************************************************
section .text
bus_cycle_0:
			mov	dword ecx, [LINE_CYCLE]
			mov	dword ebx, [LINE_COUNTER]
			inc	dword ecx
			cmp	dword ebx, [LINE_LATCH]
			mov	dword [LINE_CYCLE], ecx
			jne	.end
			mov	byte  dl, [REGISTERS + 019h]
			mov	byte  al, [REGISTERS + 01ah]
			or	byte  dl, 001h
			test	byte  al, 001h
			jz	.no_irq
			or	byte  dl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	byte  [REGISTERS + 019h], dl
.end:			mov	byte  [REGISTERS + 012h], bl
			mov	byte  al, [REGISTERS + 011h]
			ror	byte  bh, 1
			and	byte  al, 07fh
			mov	dword ecx, bus_cycle_1
			or	byte  al, bh
			mov	dword [EXECUTE_BUS_CYCLE], ecx
			mov	byte  [REGISTERS + 011h], al
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_0_new_frame ****************************************************
;****************************************************************************
section .text
bus_cycle_0_new_frame:
			call	sync_new_frame
			mov	byte  al, [REGISTERS + 011h]
			mov	dword ebx, [STATE]
			mov	dword ecx, [LINE_CYCLE]
			xor	dword edx, edx
			inc	dword ecx
			and	dword ebx, (NOT32 - DISPLAY_DISABLE)
			mov	dword [LINE_CYCLE], ecx
			mov	dword [DECODED_LINES], edx
			mov	dword [VIDEO_COUNTER], edx
			test	byte  al, 010h
			jnz	.display_enabled
			or	dword ebx, DISPLAY_DISABLE
.display_enabled:	mov	byte  [REGISTERS + 012h], dl
			and	byte  al, 07fh
			mov	dword [STATE], ebx
			mov	byte  [REGISTERS + 011h], al
			mov	dword ebx, bus_cycle_1
			cmp	dword edx, [LINE_LATCH]
			jne	.line_latch_differs
			mov	dword ebx, bus_cycle_1_new_frame
.line_latch_differs:	mov	dword [EXECUTE_BUS_CYCLE], ebx
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_1 **************************************************************
;****************************************************************************
section .text
bus_cycle_1:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_2
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_1_new_frame ****************************************************
;****************************************************************************
section .text
bus_cycle_1_new_frame:
			mov	byte  al, [REGISTERS + 01ah]
			mov	dword ecx, [LINE_CYCLE]
			mov	byte  bl, [REGISTERS + 019h]
			inc	dword ecx
			or	byte  bl, 001h
			mov	dword [LINE_CYCLE], ecx
			test	byte  al, 001h
			jz	.no_irq
			or	byte  bl, 080h
			mov	byte  al, 1
			call	c64link_vic_irq
.no_irq:		mov	dword eax, bus_cycle_2
			mov	byte  [REGISTERS + 019h], bl
			mov	dword [EXECUTE_BUS_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_2 **************************************************************
;****************************************************************************
section .text
bus_cycle_2:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_3
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_3 **************************************************************
;****************************************************************************
section .text
bus_cycle_3:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_4
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_4 **************************************************************
;****************************************************************************
section .text
bus_cycle_4:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_5
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_5 **************************************************************
;****************************************************************************
section .text
bus_cycle_5:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_6
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp
			



;****************************************************************************
;* bus_cycle_6 **************************************************************
;****************************************************************************
section .text
bus_cycle_6:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_7
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_7 **************************************************************
;****************************************************************************
section .text
bus_cycle_7:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_8
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_8 **************************************************************
;****************************************************************************
section .text
bus_cycle_8:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_9
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_9 **************************************************************
;****************************************************************************
section .text
bus_cycle_9:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_10
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_10 *************************************************************
;****************************************************************************
section .text
bus_cycle_10:
			mov	dword eax, [LINE_CYCLE]
			mov	dword edx, [LINE_COUNTER]
			inc	dword eax
			mov	dword ebx, bus_cycle_11_idle
			mov	dword [LINE_CYCLE], eax
			cmp	dword edx, 48
			jb	.idle
			cmp	dword edx, 247
			ja	.idle
			mov	dword ebx, bus_cycle_11
.idle:			mov	dword [EXECUTE_BUS_CYCLE], ebx
			jmp	cpu65xx_signal_clear_dma



;****************************************************************************
;* bus_cycle_11_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_11_idle:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_12_idle
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_12_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_12_idle:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_13_idle
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_13_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_13_idle:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_14_idle
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_14_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_14_idle:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_15_idle
			inc	dword eax
%ifdef VIC6569_DISABLE_NEW_BUS_CYCLE_15
			mov	byte  cl, 40
%endif
			mov	dword [LINE_CYCLE], eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
%ifdef VIC6569_DISABLE_NEW_BUS_CYCLE_15
			mov	byte  [BUS_CYCLE_COUNTER], cl
%endif
			BUS_CYCLE_SPRITE_COUNTER_ADD  2
			ret



;****************************************************************************
;* bus_cycle_11 *************************************************************
;****************************************************************************
section .text
bus_cycle_11:
			BUS_CYCLE_CHECK_BAD_LINE  [STATE]
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_12
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_12 *************************************************************
;****************************************************************************
section .text
bus_cycle_12:
			BUS_CYCLE_CHECK_BAD_LINE  [STATE]
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_13
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_13 *************************************************************
;****************************************************************************
section .text
bus_cycle_13:
			BUS_CYCLE_CHECK_BAD_LINE  [STATE]
			xor	dword edx, edx
			test	dword [STATE], BAD_LINE
			jz	.end
			mov	dword [ROW_COUNTER], edx
.end:			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_14
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			ret



;****************************************************************************
;* bus_cycle_14 *************************************************************
;****************************************************************************
section .text
bus_cycle_14:
			BUS_CYCLE_CHECK_BAD_LINE  [STATE]
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_15
%ifdef VIC6569_DISABLE_NEW_BUS_CYCLE_15
			mov	byte  cl, 40
%endif
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
%ifdef VIC6569_DISABLE_NEW_BUS_CYCLE_15
			mov	byte  [BUS_CYCLE_COUNTER], cl
%endif
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_SPRITE_COUNTER_ADD  2
			ret



%ifndef VIC6569_DISABLE_NEW_BUS_CYCLE_15
;****************************************************************************
;* bus_cycle_15 *************************************************************
;****************************************************************************
section .text
bus_cycle_15:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
			test	dword eax, BAD_LINE
			jz	.no_bad_line
			test	dword eax, ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			BUS_CYCLE_CHECK_BORDER_LEFT
			inc	dword ecx
			mov	dword [STATE], eax
			mov	dword ebx, bus_cycle_16
			mov	dword [LINE_CYCLE], ecx
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			BUS_CYCLE_SPRITE_COUNTER_ADD  1
			ret



;****************************************************************************
;* bus_cycle_16 *************************************************************
;****************************************************************************
section .text
bus_cycle_16:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
			test	dword eax, BAD_LINE
			jz	.no_bad_line
			test	dword eax, ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			BUS_CYCLE_CHECK_BORDER_LEFT
			inc	dword ecx
			mov	dword [STATE], eax
			mov	dword [LINE_CYCLE], ecx
			mov	dword ebx, bus_cycle_17
			mov	byte  cl, 37
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	byte  [BUS_CYCLE_COUNTER], cl
			ret



;****************************************************************************
;* bus_cycle_17 *************************************************************
;****************************************************************************
section .text
bus_cycle_17:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
			test	dword eax, BAD_LINE
			jz	.no_bad_line
			test	dword eax, ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_CHECK_BAD_LINE  eax
			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword [STATE], eax
			mov	dword ecx, [LINE_CYCLE]
			mov	byte  bl, [BUS_CYCLE_COUNTER]
			inc	dword ecx
			dec	byte  bl
			mov	dword [LINE_CYCLE], ecx
			mov	byte  [BUS_CYCLE_COUNTER], bl
			mov	dword edx, bus_cycle_54
			jnz	.end
			mov	dword [EXECUTE_BUS_CYCLE], edx
.end:			ret



;****************************************************************************
;* bus_cycle_54 *************************************************************
;****************************************************************************
section .text
bus_cycle_54:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
			test	dword eax, BAD_LINE
			jz	.no_bad_line
			test	dword eax, ACCESS_GRANTED
			jz	.read_rubbish
			BUS_CYCLE_VIDEO_READ_BAD_LINE
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_55
			inc	dword ecx
			and	dword eax, (NOT32 - BAD_LINE - ACCESS_GRANTED)
			mov	dword [LINE_CYCLE], ecx
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	byte  cl, [SPRITE_Y_EXPAND_MASK]
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			xor	byte  cl, [REGISTERS + 017h]
			mov	dword [STATE], eax
			mov	byte  [SPRITE_Y_EXPAND_MASK], cl
			BUS_CYCLE_CALCULATE_SPRITE_DMA1
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_15_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_15_idle:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	.idle
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			BUS_CYCLE_CHECK_BORDER_LEFT
			inc	dword ecx
			mov	dword [STATE], eax
			mov	dword ebx, bus_cycle_16_idle
			mov	dword [LINE_CYCLE], ecx
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			BUS_CYCLE_SPRITE_COUNTER_ADD  1
			ret



;****************************************************************************
;* bus_cycle_16_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_16_idle:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	.idle
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			BUS_CYCLE_CHECK_BORDER_LEFT
			inc	dword ecx
			mov	dword [STATE], eax
			mov	dword [LINE_CYCLE], ecx
			mov	dword ebx, bus_cycle_17_idle
			mov	byte  cl, 37
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	byte  [BUS_CYCLE_COUNTER], cl
			ret



;****************************************************************************
;* bus_cycle_17_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_17_idle:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	.idle
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword [STATE], eax
			mov	dword ecx, [LINE_CYCLE]
			mov	byte  bl, [BUS_CYCLE_COUNTER]
			inc	dword ecx
			dec	byte  bl
			mov	dword [LINE_CYCLE], ecx
			mov	byte  [BUS_CYCLE_COUNTER], bl
			mov	dword edx, bus_cycle_54_idle
			jnz	.end
			mov	dword [EXECUTE_BUS_CYCLE], edx
.end:			ret



;****************************************************************************
;* bus_cycle_54_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_54_idle:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	.idle
.no_bad_line:		BUS_CYCLE_VIDEO_READ
.data:			BUS_CYCLE_DATA_READ
			jmp	.exit
.idle:			BUS_CYCLE_IDLE_READ
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ecx, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_55
			inc	dword ecx
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], ecx
			mov	dword [STATE], eax
			BUS_CYCLE_CALCULATE_SPRITE_DMA1
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



%else
;****************************************************************************
;* bus_cycle_15 *************************************************************
;****************************************************************************
section .text
bus_cycle_15:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [VIDEO_COUNTER]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
			test	dword eax, BAD_LINE
			jz	.no_bad_line
			test	dword eax, ACCESS_GRANTED
			jz	.read_rubbish
			mov	byte  cl, [REGISTERS + 018h]
			mov	byte  dl, [C64MEMORY_COLOR_RAM + ebx]
			shl	dword ecx, 6
			or	dword ebx, [HIGH_BITS]
			and	dword ecx, 03c00h
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			or	dword ebx, ecx
			BUS_CYCLE_READ_RAM  dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.read_rubbish:		mov	byte  dl, 0ffh
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], dl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
			jmp	.data
.no_bad_line:		mov	byte  bl, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ecx]
			mov	byte  dl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ecx]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], bl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			BUS_CYCLE_CHECK_BAD_LINE  eax
			mov	byte  cl, [REGISTERS + 018h]
			shl	dword ecx, 10
			test	byte  [REGISTERS + 011h], 020h
			jz	.data_charset
			mov	dword ebx, [VIDEO_COUNTER]
			and	dword ecx, 02000h
			shl	dword ebx, 3
			jmp	.data_read
.data_charset:		xor	dword ebx, ebx
			and	dword ecx, 03800h
			mov	byte  bl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
			shl	dword ebx, 3
.data_read:		or	dword ebx, ecx
			or	dword ebx, [ROW_COUNTER]
			or	dword ebx, [HIGH_BITS]
			test	byte  [REGISTERS + 011h], 040h
			jz	.data_no_ecm
			and	byte  bh, 0f9h
.data_no_ecm:		BUS_CYCLE_READ_RAM  al
			mov	dword ecx, [VIDEO_COUNTER]
			mov	dword edx, [CACHE_OFFSET]
			mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], al
			inc	dword ecx
			inc	dword edx
			mov	dword [VIDEO_COUNTER], ecx
			jmp	.exit
.idle:			BUS_CYCLE_CHECK_BAD_LINE  eax
			mov	dword ebx, [HIGH_BITS]
			mov	dword edx, [CACHE_OFFSET]
			or	dword ebx, 03fffh
			test	byte  [REGISTERS + 011h], 040h
			jz	.idle_no_ecm
			and	byte  bh, 0f9h
.idle_no_ecm:		xor	byte  cl, cl
			inc	dword edx
			mov	byte  al, [C64MEMORY_RAM + ebx]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], cl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], cl
			mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], al
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword eax, [LINE_CYCLE]
			mov	byte  bl, [BUS_CYCLE_COUNTER]
			cmp	dword eax, [BORDER_LEFT]
			jne	.border_left_2
			mov	dword ecx, [LINE_COUNTER]
			mov	dword edx, [STATE]
			cmp	dword ecx, [BORDER_BUTTOM]
			jne	.border_buttom_1
			or	dword edx, BORDER_VERTICAL
.border_buttom_1:	cmp	dword ecx, [BORDER_TOP]
			jne	.border_top_1
			test	dword edx, DISPLAY_DISABLE
			jnz	.border_top_1
			and	dword edx, (NOT32 - BORDER_VERTICAL)
.border_top_1:		test	dword edx, BORDER_VERTICAL
			jnz	.border_left_1
			and	dword edx, (NOT32 - BORDER_MAIN)
.border_left_1:		mov	dword [STATE], edx
.border_left_2:		inc	dword eax
			dec	byte  bl
			mov	dword [LINE_CYCLE], eax
			mov	byte  [BUS_CYCLE_COUNTER], bl
			jnz	.end
			mov	dword ebx, [STATE]
			cmp	dword eax, [BORDER_RIGHT]
			jne	.border_right_1
			or	dword ebx, BORDER_MAIN
.border_right_1:	and	dword ebx, (NOT32 - BAD_LINE - ACCESS_GRANTED)
			mov	dword [EXECUTE_BUS_CYCLE], bus_cycle_55
			mov	dword [STATE], ebx
			call	cpu65xx_signal_clear_dma
.end:			ret



;****************************************************************************
;* bus_cycle_15_idle ********************************************************
;****************************************************************************
section .text
bus_cycle_15_idle:
			mov	dword eax, [STATE]
			mov	dword ecx, [CACHE_OFFSET]
			mov	dword ebx, [HIGH_BITS]
			mov	dword ebp, ecx
			add	dword ecx, [LAST_LINE_ADDRESS]
			add	dword ebp, [LINE_ADDRESS]
			test	dword eax, DISPLAY_MODE
			jz	near  .idle
.no_bad_line:		mov	byte  bl, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ecx]
			mov	byte  dl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ecx]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], bl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], dl
.data:			mov	byte  cl, [REGISTERS + 018h]
			mov	byte  al, [REGISTERS + 011h]
			shl	dword ecx, 10
			test	byte  al, 020h
			jz	.data_charset
			mov	dword ebx, [VIDEO_COUNTER]
			and	dword ecx, 02000h
			shl	dword ebx, 3
			jmp	.data_read
.data_charset:		xor	dword ebx, ebx
			and	dword ecx, 03800h
			mov	byte  bl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
			shl	dword ebx, 3
.data_read:		or	dword ebx, ecx
			or	dword ebx, [ROW_COUNTER]
			or	dword ebx, [HIGH_BITS]
			test	byte  al, 040h
			jz	.data_no_ecm
			and	byte  bh, 0f9h
.data_no_ecm:		BUS_CYCLE_READ_RAM  al
			mov	dword ecx, [VIDEO_COUNTER]
			mov	dword edx, [CACHE_OFFSET]
			mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], al
			inc	dword ecx
			inc	dword edx
			mov	dword [VIDEO_COUNTER], ecx
			jmp	.exit
.idle:			mov	byte  al, [REGISTERS + 011h]
			or	dword ebx, 03fffh
			test	byte  al, 040h
			jz	.idle_no_ecm
			and	byte  bh, 0f9h
.idle_no_ecm:		mov	dword edx, [CACHE_OFFSET]
			xor	byte  cl, cl
			inc	dword edx
			mov	byte  al, [C64MEMORY_RAM + ebx]
			mov	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], cl
			mov	byte  [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp], cl
			mov	byte  [LAST_FRAME + VICLINE_DATA_CACHE + ebp], al
.exit:			mov	dword [CACHE_OFFSET], edx
			mov	dword ebx, [LINE_CYCLE]
			mov	byte  dl, [BUS_CYCLE_COUNTER]
			cmp	dword ebx, [BORDER_LEFT]
			jne	.border_left_2
			mov	dword ecx, [LINE_COUNTER]
			mov	dword edi, [STATE]
			cmp	dword ecx, [BORDER_BUTTOM]
			jne	.border_buttom_1
			or	dword edi, BORDER_VERTICAL
.border_buttom_1:	cmp	dword ecx, [BORDER_TOP]
			jne	.border_top_1
			test	dword edi, DISPLAY_DISABLE
			jnz	.border_top_1
			and	dword edi, (NOT32 - BORDER_VERTICAL)
.border_top_1:		test	dword edi, BORDER_VERTICAL
			jnz	.border_left_1
			and	dword edi, (NOT32 - BORDER_MAIN)
.border_left_1:		mov	dword [STATE], edi
.border_left_2:		inc	dword ebx
			dec	byte  dl
			mov	dword [LINE_CYCLE], ebx
			mov	byte  [BUS_CYCLE_COUNTER], dl
			jnz	.end
			mov	dword eax, [STATE]
			cmp	dword ebx, [BORDER_RIGHT]
			jne	.border_right_1
			or	dword eax, BORDER_MAIN
			mov	dword [STATE], eax
.border_right_1:	mov	dword [EXECUTE_BUS_CYCLE], bus_cycle_55
.end:			ret
%endif



;****************************************************************************
;* bus_cycle_55 *************************************************************
;****************************************************************************
section .text
bus_cycle_55:
			mov	dword ecx, [LINE_CYCLE]
			mov	dword eax, [STATE]
			inc	dword ecx
			mov	dword ebx, bus_cycle_56
			mov	dword [LINE_CYCLE], ecx
			BUS_CYCLE_CHECK_BORDER_RIGHT
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [STATE], eax
			BUS_CYCLE_CALCULATE_SPRITE_DMA2
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_56 *************************************************************
;****************************************************************************
section .text
bus_cycle_56:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_57
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_57 *************************************************************
;****************************************************************************
section .text
bus_cycle_57:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_58
			mov	dword ecx, [VIDEO_COUNTER]
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			mov	dword ebx, [ROW_COUNTER]
			mov	dword eax, [STATE]
			cmp	byte  bl, 7
			jb	.no_wrap
			xor	dword ebx, ebx
			and	dword eax, (NOT32 - DISPLAY_MODE)
			mov	dword [ROW_COUNTER], ebx
			mov	dword [STATE], eax
			jmp	.end
.no_wrap:		test	dword eax, DISPLAY_MODE
			jz	.end
			sub	dword ecx, byte 40
			inc	dword ebx
			and	dword ecx, 003ffh
			mov	dword [ROW_COUNTER], ebx
			mov	dword [VIDEO_COUNTER], ecx
.end:			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_58 *************************************************************
;****************************************************************************
section .text
bus_cycle_58:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_59
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_59 *************************************************************
;****************************************************************************
section .text
bus_cycle_59:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_60
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret



;****************************************************************************
;* bus_cycle_60 *************************************************************
;****************************************************************************
section .text
bus_cycle_60:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_61
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp



;****************************************************************************
;* bus_cycle_61 *************************************************************
;****************************************************************************
section .text
bus_cycle_61:
			mov	dword eax, [LINE_CYCLE]
			mov	dword ebx, bus_cycle_62
			inc	dword eax
			mov	dword [EXECUTE_BUS_CYCLE], ebx
			mov	dword [LINE_CYCLE], eax
			BUS_CYCLE_CHECK_SPRITE_DMA  call
			BUS_CYCLE_SPRITE_READ
			ret


;****************************************************************************
;* bus_cycle_62 *************************************************************
;****************************************************************************
section .text
bus_cycle_62:
			;-------------------------------
			;clear unused CHANGE_LOG entries
			;-------------------------------

			cld
			mov	dword ecx, CHANGE_LOG_SIZE
			mov	dword edx, [CHANGE_LOG_OFFSET]
			sub	dword ecx, edx
			jz	.change_log_full
			mov	dword eax, [MODUL_ID]
			jc	near  core_exception
			mov	dword ebx, [LINE_ADDRESS]
			shl	dword edx, 2
			add	dword ebx, edx
			xor	dword eax, eax
			lea	dword edi, [LAST_FRAME + VICLINE_CHANGE_LOG + ebx]
			rep stosd
.change_log_full:
%ifndef VIC6569_DISABLE_SELECTIVE_DECODING
			;---------------------------------------------
			;compare data from LINE_ADDRESS with data from
			;the frame before stored at NEXT_LINE_ADDRESS
			;---------------------------------------------

			mov	dword eax, [LINE_ADDRESS]
			mov	dword ebx, [NEXT_LINE_ADDRESS]
			mov	dword ecx, (VICLINE_SIZE / 4)
			push	dword esi
			lea	dword edx, [LAST_FRAME + eax]
			lea	dword ebp, [LAST_FRAME + ebx]
			mov	dword esi, edx
			mov	dword edi, ebp
			repe cmpsd
			pop	dword esi
			mov	dword ebp, ecx
%endif

			;--------------------------------
			;copy REGISTERS for the next line
			;--------------------------------

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;copy only selected VIC registers to next line and not all like now
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			mov	dword eax, [NEXT_LINE_ADDRESS]
			mov	dword ecx, (REGISTERS_SIZE / 4)
			push	dword esi
			lea	dword ebx, [REGISTERS]
			lea	dword edx, [LAST_FRAME + VICLINE_REGISTERS + eax]
			mov	dword esi, ebx
			mov	dword edi, edx
			rep movsd
			pop	dword esi
%ifndef VIC6569_DISABLE_SELECTIVE_DECODING
			or	dword ebp, ebp
			jz	.skip_decoding
%endif

			;----------------------------------------------------
			;copy REGISTERS from LINE_ADDRESS to DECODE_REGISTERS
			;and decode the line
			;----------------------------------------------------

			mov	dword ebx, [DECODED_LINES]
			mov	dword eax, [LINE_ADDRESS]
			inc	dword ebx
			mov	dword ecx, (REGISTERS_SIZE / 4)
			mov	dword [DECODED_LINES], ebx
			push	dword esi
			lea	dword ebx, [LAST_FRAME + VICLINE_REGISTERS + eax]
			lea	dword edx, [DECODE_REGISTERS]
			mov	dword esi, ebx
			mov	dword edi, edx
			rep movsd
			pop	dword esi
			call	decode_line
.skip_decoding:
			;---------------------------------------------
			;increment LAST_LINE_ADDRESS, LINE_ADDRESS and
			;NEXT_LINE_ADDRESS
			;---------------------------------------------

			mov	dword eax, [LINE_ADDRESS]
			mov	dword ebx, [NEXT_LINE_ADDRESS]
			xor	dword ecx, ecx
			mov	dword [LAST_LINE_ADDRESS], eax
			mov	dword [LINE_ADDRESS], ebx
			mov	dword [LINE_CYCLE], ecx
			mov	dword [CACHE_OFFSET], ecx
			add	dword ebx, VICLINE_SIZE
			mov	dword [CHANGE_LOG_OFFSET], ecx
			cmp	dword ebx, ((LINES_PER_FRAME + 1) * VICLINE_SIZE)
			jb	.no_frame_wrap
			xor	dword ebx, ebx
.no_frame_wrap:		mov	dword [NEXT_LINE_ADDRESS], ebx

			;--------------------------------------------------
			;check border conditions and increment LINE_COUNTER
			;--------------------------------------------------

			mov	dword ebx, [LINE_COUNTER]
			mov	dword eax, [STATE]
			cmp	dword ebx, [BORDER_BUTTOM]
			jne	.border_buttom
			or	dword eax, BORDER_VERTICAL
.border_buttom:		cmp	dword ebx, [BORDER_TOP]
			jne	.border_top
			test	dword eax, DISPLAY_DISABLE
			jnz	.border_top
			and	dword eax, (NOT32 - BORDER_VERTICAL)
.border_top:		mov	dword ecx, bus_cycle_0
			mov	dword [STATE], eax
			mov	dword edx, [SCREEN]
			inc	dword ebx
			add	dword edx, [SCREEN_LINE_LENGTH]
			cmp	dword ebx, LINES_PER_FRAME
			jb	.no_line_wrap
			mov	dword edx, [SCREEN_START]
			xor	dword ebx, ebx
			mov	dword ecx, bus_cycle_0_new_frame
.no_line_wrap:		mov	dword [SCREEN], edx
			mov	dword [LINE_COUNTER], ebx
			mov	dword [EXECUTE_BUS_CYCLE], ecx
			BUS_CYCLE_CHECK_SPRITE_DMA  jmp





;****************************************************************************
;****************************************************************************
;*
;* PART ?.?: Global Decoding Functions
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* decode_select ************************************************************
;****************************************************************************
section .text
decode_select:
			;-----------------------------
			;decide what we have to decode
			;-----------------------------

			xor	dword eax, eax
			test	byte  [DECODE_REGISTERS + 011h], 020h
			jz	.no_bitmap
			or	byte  al, 004h
.no_bitmap:		test	byte  [DECODE_REGISTERS + 011h], 040h
			jz	.no_ecm
			or	byte  al, 002h
.no_ecm:		test	byte  [DECODE_REGISTERS + 016h], 010h
			jz	.no_mcm
			or	byte  al, 001h
.no_mcm:		mov	dword eax, [.ap__decode_cycle_functions + 4 * eax]
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW], eax
			ret

			align 4
.ap__decode_cycle_functions:
			dd	decode_cycle_window.text
			dd	decode_cycle_window.text_mcm
			dd	decode_cycle_window.text_ecm
			dd	decode_cycle_window.text_ecm_mcm
			dd	decode_cycle_window.bitmap
			dd	decode_cycle_window.bitmap_mcm
			dd	decode_cycle_window.bitmap_ecm
			dd	decode_cycle_window.bitmap_ecm_mcm




;****************************************************************************
;* decode_cycle_window ******************************************************
;****************************************************************************
section .text
decode_cycle_window:
			;-----------------------------
			;set colors for hires textmode
			;-----------------------------

.text:			xor	dword ebx, ebx
			mov	byte  al, [DECODE_REGISTERS + 021h]
			mov	byte  bl, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	byte  al, 00fh
			and	byte  bl, 00fh
			mov	byte  [COLOR_LOOKUP_TABLE], al
			mov	byte  [COLOR_LOOKUP_TABLE + 1], bl
			jmp	.decode

			;-----------------------
			;set colors for mcm text
			;-----------------------

.text_mcm:		test	byte  [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp], 008h
			jz	.text
			mov	byte  bh, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			mov	byte  al, [DECODE_REGISTERS + 021h]
			mov	byte  bl, [DECODE_REGISTERS + 022h]
			mov	byte  ah, [DECODE_REGISTERS + 023h]
			and	dword eax, 00f0fh
			and	dword ebx, 0070fh
			mov	byte  [COLOR_LOOKUP_TABLE], al
			mov	byte  [COLOR_LOOKUP_TABLE + 1], bl
			mov	byte  [COLOR_LOOKUP_TABLE + 2], ah
			mov	byte  [COLOR_LOOKUP_TABLE + 3], bh
			mov	byte  bh, 1
			jmp	.decode

			;-----------------------
			;set colors for ecm text
			;-----------------------

.text_ecm:		xor	dword ebx, ebx
			mov	byte  bl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
			shr	byte  bl, 6
			mov	byte  al, [DECODE_REGISTERS + 021h + ebx]
			mov	byte  bl, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	byte  al, 00fh
			and	byte  bl, 00fh
			mov	byte  [COLOR_LOOKUP_TABLE], al
			mov	byte  [COLOR_LOOKUP_TABLE + 1], bl
			jmp	.decode

			;---------------------------
			;set colors for hires bitmap
			;---------------------------

.bitmap:		mov	byte  al, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
			mov	byte  bl, al
			and	byte  al, 00fh
			shr	byte  bl, 4
			mov	byte [COLOR_LOOKUP_TABLE], al
			mov	byte [COLOR_LOOKUP_TABLE + 1], bl
			xor	dword ebx, ebx
			jmp	.decode

			;-------------------------
			;set colors for mcm bitmap
			;-------------------------

.bitmap_mcm:		mov	byte  al, [DECODE_REGISTERS + 021h]
			mov	byte  bl, [LAST_FRAME + VICLINE_VIDEO_CACHE + ebp]
			mov	byte  ah, bl
			shr	byte  bl, 4
			mov	byte  bh, [LAST_FRAME + VICLINE_COLOR_RAM_CACHE + ebp]
			and	dword eax, 00f0fh
			and	dword ebx, 00f0fh
			mov	byte  [COLOR_LOOKUP_TABLE], al
			mov	byte  [COLOR_LOOKUP_TABLE + 1], bl
			mov	byte  [COLOR_LOOKUP_TABLE + 2], ah
			mov	byte  [COLOR_LOOKUP_TABLE + 3], bh
			mov	byte  bh, 1
			jmp	.decode

			;-------------------------------------------
			;set colors for illegal modes (always black)
			;-------------------------------------------

.text_ecm_mcm:
.bitmap_ecm:
.bitmap_ecm_mcm:	xor	dword ebx, ebx
			test	byte  [DECODE_REGISTERS + 016h], 010h
			mov	dword [COLOR_LOOKUP_TABLE], ebx
			setnz	byte  bh

			;-------------------------------------
			;decode data with the above set colors
			;-------------------------------------

.decode:		xor	dword eax, eax
			mov	byte  bl, [LAST_FRAME + VICLINE_DATA_CACHE + ebp]
			mov	dword ecx, [SCROLL_CACHE + 8]
			mov	byte  al, [DECODE_REGISTERS + 016h]
			mov	dword edx, [SCROLL_CACHE + 12]
			mov	dword [SCROLL_CACHE], ecx
			and	byte  al, 007h
			mov	dword [SCROLL_CACHE + 4], edx
			mov	dword ebp, eax
			mov	dword edi, ebx
			xor	dword eax, eax
			xor	dword ebx, ebx
			mov	byte  al, [decode_tables + 8 * edi]
			xor	dword ecx, ecx
			mov	byte  bl, [decode_tables + 8 * edi + 4]
			xor	dword edx, edx
			mov	byte  cl, [decode_tables + 8 * edi + 1]
			mov	byte  al, [COLOR_LOOKUP_TABLE + eax]
			mov	byte  dl, [decode_tables + 8 * edi + 5]
			mov	byte  bl, [COLOR_LOOKUP_TABLE + ebx]
			mov	byte  [SCROLL_CACHE + ebp + 7], al
			mov	byte  cl, [COLOR_LOOKUP_TABLE + ecx]
			mov	byte  [SCROLL_CACHE + ebp + 6], bl
			mov	byte  dl, [COLOR_LOOKUP_TABLE + edx]
			mov	byte  [SCROLL_CACHE + ebp + 5], cl
			mov	byte  al, [decode_tables + 8 * edi + 2]
			mov	byte  [SCROLL_CACHE + ebp + 4], dl
			mov	byte  bl, [decode_tables + 8 * edi + 6]
			mov	byte  cl, [decode_tables + 8 * edi + 3]
			mov	byte  al, [COLOR_LOOKUP_TABLE + eax]
			mov	byte  dl, [decode_tables + 8 * edi + 7]
			mov	byte  bl, [COLOR_LOOKUP_TABLE + ebx]
			mov	byte  [SCROLL_CACHE + ebp + 3], al
			mov	byte  cl, [COLOR_LOOKUP_TABLE + ecx]
			mov	byte  [SCROLL_CACHE + ebp + 2], bl
			mov	byte  dl, [COLOR_LOOKUP_TABLE + edx]
			mov	byte  [SCROLL_CACHE + ebp + 1], cl
			mov	byte  [SCROLL_CACHE + ebp], dl
			ret



;****************************************************************************
;* decode_line **************************************************************
;****************************************************************************
section .text
decode_line:
			mov	dword ebx, [LINE_COUNTER]
			cmp	dword ebx, [Y_START]
			jb	.end
			cmp	dword ebx, [Y_END]
			jae	.end
			mov	dword ebx, [LINE_ADDRESS]
			xor	dword ecx, ecx
			xor	dword edx, edx
			jmp	.no_change
.loop:			mov	dword eax, [LAST_FRAME + VICLINE_CHANGE_LOG + ebx]
			inc	dword ecx
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			shr	dword eax, 8
			add	dword ebx, 4
			mov	byte  dl, ah
			mov	byte  [DECODE_REGISTERS + edx], al
.no_change:		cmp	dword ecx, [X_START]
			jb	.loop
			mov	dword eax, [STATE]
			test	dword eax, BORDER_MAIN
			jz	.overscan
			test	dword eax, BORDER_VERTICAL
			jz	.window
			jmp	dword [DECODE_FUNCTIONS + VICDECODE_BORDER]
.window:		jmp	dword [DECODE_FUNCTIONS + VICDECODE_WINDOW]
.overscan:		jmp	dword [DECODE_FUNCTIONS + VICDECODE_OVERSCAN]
.end:			ret



;****************************************************************************
;* decode_overscan **********************************************************
;****************************************************************************
section .text
decode_overscan:
			ret



;****************************************************************************
;* decode_window ************************************************************
;****************************************************************************
section .text
decode_window:
			call	decode_select
.loop:			xor	dword edx, edx
			mov	dword eax, [LAST_FRAME + VICLINE_CHANGE_LOG + ebx]
			mov	byte  dl, [.ab__decode_functions + ecx]
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			push	dword ebx
			shr	dword eax, 8
			xor	dword ebx, ebx
			mov	byte  bl, ah
			mov	byte  [DECODE_REGISTERS + ebx], al
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;ap__change_functions ==> decode_select must be called
			cmp	byte  ah, 011h
			je	.select
			cmp	byte  ah, 016h
			jne	.skip_select
.select:		call	decode_select
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
.skip_select:		pop	dword ebx
			add	dword ebx, 4
.no_change:		call	dword [DECODE_FUNCTIONS + edx]
			inc	dword ecx
			cmp	dword ecx, [X_END]
			jb	.loop
			ret

.ab__decode_functions:	times 15	db	VICDECODE_CYCLE_BORDER
					db	VICDECODE_CYCLE_WINDOW_LEFT
			times 37	db	VICDECODE_CYCLE_WINDOW_CENTRAL
					db	VICDECODE_CYCLE_WINDOW_RIGHT1
					db	VICDECODE_CYCLE_WINDOW_RIGHT2
			times 8		db	VICDECODE_CYCLE_BORDER





;****************************************************************************
;****************************************************************************
;*
;* PART ?.?: Decoding Functions for 8bpp
;*
;****************************************************************************
;****************************************************************************




%ifdef VIC6569_ENABLE_8BPP
;****************************************************************************
;* decode_border_8bpp *******************************************************
;****************************************************************************
section .text
decode_border_8bpp:
			mov	byte  dl, [DECODE_REGISTERS + 020h]
			mov	dword edi, [SCREEN]
			and	byte  dl, 00fh
			mov	byte  dh, dl
			mov	byte  al, dl
			shl	dword edx, 16
			mov	byte  dl, al
			mov	byte  dh, al
.loop:			mov	dword eax, [LAST_FRAME + VICLINE_CHANGE_LOG + ebx]
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			shr	dword eax, 8
			add	dword ebx, 4
			cmp	byte  ah, 020h
			jne	.no_change
			mov	byte  dl, al
			and	byte  dl, 00fh
			mov	byte  dh, dl
			mov	byte  al, dl
			shl	dword edx, 16
			mov	byte  dl, al
			mov	byte  dh, al
.no_change:		mov	dword [edi + 8 * ecx], edx
			mov	dword [edi + 8 * ecx + 4], edx
			inc	dword ecx
			cmp	dword ecx, [X_END]
			jb	.loop
			ret



;****************************************************************************
;* decode_window_8bpp *******************************************************
;****************************************************************************
section .text
decode_window_8bpp:	equ	decode_window



;****************************************************************************
;* decode_overscan_8bpp *****************************************************
;****************************************************************************
section .text
decode_overscan_8bpp:
			ret



;****************************************************************************
;* decode_cycle_border_8bpp *************************************************
;****************************************************************************
section .text
decode_cycle_border_8bpp:
			mov	byte  al, [DECODE_REGISTERS + 020h]
			mov	dword edi, [SCREEN]
			and	byte  al, 00fh
			mov	byte  ah, al
			mov	byte  dl, al
			shl	dword eax, 16
			mov	byte  al, dl
			mov	byte  ah, dl
			mov	dword [edi + 8 * ecx], eax
			mov	dword [edi + 8 * ecx + 4], eax
			ret



;****************************************************************************
;* decode_cycle_window_left_8bpp ********************************************
;****************************************************************************
section .text
decode_cycle_window_left_8bpp:
			mov	byte  al, [DECODE_REGISTERS + 021h]
			mov	dword ebp, [LINE_ADDRESS]
			and	byte  al, 00fh
			mov	byte  ah, al
			mov	byte  dl, al
			lea	dword ebp, [ebp + ecx - 15]
			shl	dword eax, 16
			mov	byte  al, dl
			mov	byte  ah, dl
			push	dword ebx
			mov	dword [SCROLL_CACHE + 8], eax
			push	dword ecx
			mov	dword [SCROLL_CACHE + 12], eax
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			mov	dword edi, [SCREEN]
			pop	dword ecx
			pop	dword ebx
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	near  decode_cycle_window_central_8bpp.full
			mov	byte  al, [DECODE_REGISTERS + 020h]
			and	byte  al, 00fh
			mov	byte  ah, al
			mov	byte  dl, al
			shl	dword eax, 16
			mov	byte  al, dl
			mov	byte  ah, dl
			mov	dword [edi + 8 * ecx], eax
			mov	byte  al, [SCROLL_CACHE + 7]
			ror	dword eax, 8
			mov	dword [edi + 8 * ecx + 4], eax
			ret


;****************************************************************************
;* decode_cycle_window_right1_8bpp ******************************************
;****************************************************************************
section .text
decode_cycle_window_right1_8bpp:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	decode_cycle_window_central_8bpp
			mov	dword ebp, [LINE_ADDRESS]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 15]
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			mov	dword edi, [SCREEN]
			pop	dword ecx
			pop	dword ebx
			mov	dword eax, [SCROLL_CACHE]
			mov	dword edx, [SCROLL_CACHE + 4]
			mov	dword [edi + 8 * ecx], eax
			shl	dword edx, 8
			mov	byte  dl, [DECODE_REGISTERS + 020h]
			and	byte  dl, 00fh
			ror	dword edx, 8
			mov	dword [edi + 8 * ecx + 4], edx
			ret



;****************************************************************************
;* decode_cycle_window_right2_8bpp ******************************************
;****************************************************************************
section .text
decode_cycle_window_right2_8bpp:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jz	near  decode_cycle_border_8bpp



;****************************************************************************
;* decode_cycle_window_central_8bpp *****************************************
;****************************************************************************
section .text
decode_cycle_window_central_8bpp:
			mov	dword ebp, [LINE_ADDRESS]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 15]
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			mov	dword edi, [SCREEN]
			pop	dword ecx
			pop	dword ebx
.full:			mov	dword eax, [SCROLL_CACHE]
			mov	dword edx, [SCROLL_CACHE + 4]
			mov	dword [edi + 8 * ecx], eax
			mov	dword [edi + 8 * ecx + 4], edx
			ret



%else
decode_border_8bpp:
decode_window_8bpp:
decode_overscan_8bpp:
decode_cycle_border_8bpp:
decode_cycle_window_left_8bpp:
decode_cycle_window_central_8bpp:
decode_cycle_window_right1_8bpp:
decode_cycle_window_right2_8bpp:
			ret
%endif





;****************************************************************************
;****************************************************************************
;*
;* PART ?.?: Decoding Functions for 4bpp
;*
;****************************************************************************
;****************************************************************************




%ifdef VIC6569_ENABLE_4BPP
;****************************************************************************
;* transform_to_planes ******************************************************
;****************************************************************************
section .text
transform_to_planes:
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;should <mov byte xx, [SCROLL_CACHE]> followed by an <and byte xx, 00fh> ??
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			push	dword ebx 
			push	dword ecx
			xor	dword eax, eax
			xor	dword ebx, ebx
			mov	byte  al, [SCROLL_CACHE]
			xor	dword ecx, ecx
			mov	byte  bl, [SCROLL_CACHE + 1]
			xor	dword edx, edx
			mov	byte  cl, [SCROLL_CACHE + 2]
			mov	dword ebp, [transform_table + 4 * eax]
			mov	byte  dl, [SCROLL_CACHE + 3]
			shl	dword ebp, 1
			or	dword ebp, [transform_table + 4 * ebx]
			mov	byte  al, [SCROLL_CACHE + 4]
			shl	dword ebp, 1
			or	dword ebp, [transform_table + 4 * ecx]
			mov	dword eax, [transform_table + 4 * eax]
			mov	byte  bl, [SCROLL_CACHE + 5]
			shl	dword ebp, 1
			shl	dword eax, 1
			or	dword ebp, [transform_table + 4 * edx]
			or	dword eax, [transform_table + 4 * ebx]
			mov	byte  cl, [SCROLL_CACHE + 6]
			shl	dword eax, 1
			shl	dword ebp, 4
			or	dword eax, [transform_table + 4 * ecx]
			mov	byte  dl, [SCROLL_CACHE + 7]
			pop	dword ecx
			mov	dword edi, [PLANE_SHIFT]
			shl	dword eax, 1
			add	dword edi, ecx
			or	dword eax, ebp
			sub	dword edi, [X_START]
			pop	dword ebx
			or	dword eax, [transform_table + 4 * edx]
			mov	byte  [PLANE_CACHE + edi], al
			mov	byte  [PLANE_CACHE + edi + 68], ah
			shr	dword eax, 16
			mov	byte  [PLANE_CACHE + edi + 136], al
			mov	byte  [PLANE_CACHE + edi + 204], ah
			ret



;****************************************************************************
;* decode_border_4bpp *******************************************************
;****************************************************************************
section .text
decode_border_4bpp:
			mov	byte  al, [DECODE_REGISTERS + 020h]
			mov	dword edi, [PLANE_SHIFT]
			and	dword eax, 00fh
			add	dword edi, ecx
			xor	byte  al, 00fh
			sub	dword edi, [X_START]
			mov	dword edx, [transform_table + 4 * eax]
			dec	byte  dl
			dec	byte  dh
			ror	dword edx, 16
			dec	byte  dl
			dec	byte  dh
			ror	dword edx, 16
.loop:			mov	dword eax, [LAST_FRAME + VICLINE_CHANGE_LOG + ebx]
			or	dword eax, eax
			jz	.no_change
			cmp	byte  al, cl
			jne	.no_change
			shr	dword eax, 8
			add	dword ebx, 4
			cmp	byte  ah, 020h
			jne	.no_change
			and	dword eax, 00fh
			xor	byte  al, 00fh
			mov	dword edx, [transform_table + 4 * eax]
			dec	byte  dl
			dec	byte  dh
			ror	dword edx, 16
			dec	byte  dl
			dec	byte  dh
			ror	dword edx, 16
.no_change:		mov	byte  [PLANE_CACHE + edi], dl
			mov	byte  [PLANE_CACHE + edi + 68], dh
			ror	dword edx, 16
			mov	byte  [PLANE_CACHE + edi + 136], dl
			mov	byte  [PLANE_CACHE + edi + 204], dh
			inc	dword ecx
			inc	dword edi
			ror	dword edx, 16
			cmp	dword ecx, [X_END]
			jb	.loop
			mov	dword eax, 3
			sub	dword ecx, [X_START]
			add	dword eax, [PLANE_SHIFT]
			lea	dword ebx, [PLANE_CACHE]
			add	dword eax, ecx
			mov	dword edi, [SCREEN]
			shr	dword eax, 2
			jmp	fb_draw_line



;****************************************************************************
;* decode_window_4bpp *******************************************************
;****************************************************************************
section .text
decode_window_4bpp:
			call	decode_window
			mov	dword eax, 3
			sub	dword ecx, [X_START]
			add	dword eax, [PLANE_SHIFT]
			lea	dword ebx, [PLANE_CACHE]
			add	dword eax, ecx
			mov	dword edi, [SCREEN]
			shr	dword eax, 2
			jmp	fb_draw_line



;****************************************************************************
;* decode_overscan_4bpp *****************************************************
;****************************************************************************
section .text
decode_overscan_4bpp:
			ret



;****************************************************************************
;* decode_cycle_border_4bpp *************************************************
;****************************************************************************
section .text
decode_cycle_border_4bpp:
			mov	byte  al, [DECODE_REGISTERS + 020h]
			mov	dword edi, [PLANE_SHIFT]
			and	dword eax, 00fh
			add	dword edi, ecx
			xor	byte  al, 00fh
			sub	dword edi, [X_START]
			mov	dword edx, [transform_table + 4 * eax]
			dec	byte  dl
			mov	byte  [PLANE_CACHE + edi], dl
			dec	byte  dh
			mov	byte  [PLANE_CACHE + edi + 68], dh
			shr	dword edx, 16
			dec	byte  dl
			mov	byte  [PLANE_CACHE + edi + 136], dl
			dec	byte  dh
			mov	byte  [PLANE_CACHE + edi + 204], dh
			ret


;****************************************************************************
;* decode_cycle_window_left_4bpp ********************************************
;****************************************************************************
section .text
decode_cycle_window_left_4bpp:
			mov	byte  al, [DECODE_REGISTERS + 021h]
			mov	dword ebp, [LINE_ADDRESS]
			and	byte  al, 00fh
			mov	byte  ah, al
			mov	byte  dl, al
			lea	dword ebp, [ebp + ecx - 15]
			shl	dword eax, 16
			mov	byte  al, dl
			mov	byte  ah, dl
			push	dword ebx
			mov	dword [SCROLL_CACHE + 8], eax
			push	dword ecx
			mov	dword [SCROLL_CACHE + 12], eax
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			mov	dword edi, [SCREEN]
			pop	dword ecx
			pop	dword ebx
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	.end
			mov	byte  al, [DECODE_REGISTERS + 020h]
			and	byte  al, 00fh
			mov	byte  dl, al
			mov	byte  [SCROLL_CACHE], al
			mov	byte  [SCROLL_CACHE + 4], dl
			mov	byte  [SCROLL_CACHE + 1], al
			mov	byte  [SCROLL_CACHE + 5], dl
			mov	byte  [SCROLL_CACHE + 2], al
			mov	byte  [SCROLL_CACHE + 6], dl
			mov	byte  [SCROLL_CACHE + 3], al
.end:			jmp	transform_to_planes



;****************************************************************************
;* decode_cycle_window_right1_4bpp ******************************************
;****************************************************************************
section .text
decode_cycle_window_right1_4bpp:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jnz	decode_cycle_window_central_4bpp
			mov	dword ebp, [LINE_ADDRESS]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 15]
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			mov	dword edi, [SCREEN]
			mov	byte  al, [DECODE_REGISTERS + 020h]
			pop	dword ecx
			and	byte  al, 00fh
			pop	dword ebx
			mov	byte  [SCROLL_CACHE + 7], al
			jmp	transform_to_planes



;****************************************************************************
;* decode_cycle_window_right2_4bpp ******************************************
;****************************************************************************
section .text
decode_cycle_window_right2_4bpp:
			test	byte  [DECODE_REGISTERS + 016h], 008h
			jz	near  decode_cycle_border_4bpp



;****************************************************************************
;* decode_cycle_window_central_4bpp *****************************************
;****************************************************************************
section .text
decode_cycle_window_central_4bpp:
			mov	dword ebp, [LINE_ADDRESS]
			push	dword ebx
			push	dword ecx
			lea	dword ebp, [ebp + ecx - 15]
			call	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW]
			pop	dword ecx
			pop	dword ebx
			jmp	transform_to_planes



%else
decode_border_4bpp:
decode_window_4bpp:
decode_overscan_4bpp:
decode_cycle_border_4bpp:
decode_cycle_window_left_4bpp:
decode_cycle_window_central_4bpp:
decode_cycle_window_right1_4bpp:
decode_cycle_window_right2_4bpp:
			ret
%endif



;****************************************************************************
;* vic6569_signal_high_bits *************************************************
;****************************************************************************
section .text
vic6569_signal_high_bits:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			shl	dword eax, 14
			xor	dword ebx, ebx
			xor	dword ecx, ecx
			mov	byte  bl, [REGISTERS + 018h]
			and	dword eax, 0c000h
			mov	byte  cl, bl
			shl	dword ebx, 6
			mov	dword [HIGH_BITS], eax
			and	dword ebx, 03c00h
			shl	dword ecx, 10
			mov	dword edx, [STATE]
			and	dword ecx, 03800h
			or	dword eax, ebx
			and	dword edx, (NOT32 - VIDEO_ADDRESS_IN_CHARACTER_ROM - DATA_ADDRESS_IN_CHARACTER_ROM)
			CHECK_ADDRESS  edx, VIDEO_ADDRESS_IN_CHARACTER_ROM
			mov	dword [VIDEO_ADDRESS], eax
			test	dword edx, DATA_ADDRESS_IS_BITMAP
			mov	dword eax, [HIGH_BITS]
			jz	.no_bitmap
			and	dword ecx, 02000h
.no_bitmap:		or	dword eax, ecx
			CHECK_ADDRESS  edx, DATA_ADDRESS_IN_CHARACTER_ROM
			mov	dword [DATA_ADDRESS], eax
			mov	dword [STATE], edx
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* vic6569_screen_initialize ************************************************
;****************************************************************************
section .text
vic6569_screen_initialize:
			cmp	dword [d__fb_access_mode], FB_4BPP_MODE
			je	.4bpp
			cmp	dword [d__fb_access_mode], FB_8BPP_MODE
			je	near  .8bpp
			ret

.4bpp:			mov	dword ebx, [Y_END]
			mov	dword edx, [X_END]
			sub	dword ebx, [Y_START]
			sub	dword edx, [X_START]
			mov	dword ecx, [d__x_resolution]
			mov	dword eax, [d__y_resolution]
			shr	dword ecx, 3
			sub	dword eax, ebx
			mov	dword ebx, [d__x_resolution]
			sub	dword ecx, edx
			add	dword ebx, [d__x_padding]
			shr	dword eax, 1
			shr	dword ebx, 3
			shr	dword ecx, 1
			mov	dword [SCREEN_LINE_LENGTH], ebx
			mul	dword ebx
			add	dword ecx, eax
;			mov	dword edx, [X_START]
			add	dword ecx, [p__fb_address]
			mov	dword eax, [Y_START]
;			sub	dword ecx, edx
			mul	dword ebx
			xor	dword edx, edx
			sub	dword ecx, eax
			mov	byte  dl, cl
			and	byte  cl, 0fch		;dword align
			mov	dword [SCREEN_START], ecx
			and	byte  dl, 003h
			mov	dword [SCREEN], ecx
%ifdef VIC6569_ENABLE_4BPP
			mov	dword [PLANE_SHIFT], edx
%endif
			mov	dword [DECODE_FUNCTIONS + VICDECODE_BORDER], decode_border_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_WINDOW], decode_window_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_OVERSCAN], decode_overscan_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_BORDER], decode_cycle_border_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_LEFT], decode_cycle_window_left_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_CENTRAL], decode_cycle_window_central_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_RIGHT1], decode_cycle_window_right1_4bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_RIGHT2], decode_cycle_window_right2_4bpp
			ret

.8bpp:			mov	dword ebx, [Y_END]
			mov	dword edx, [X_END]
			sub	dword ebx, [Y_START]
			sub	dword edx, [X_START]
			mov	dword eax, [d__y_resolution]
			shl	dword edx, 3
			mov	dword ecx, [d__x_resolution]
			sub	dword eax, ebx
			sub	dword ecx, edx
			mov	dword ebx, [d__x_resolution]
			shr	dword eax, 1
			add	dword ebx, [d__x_padding]
			shr	dword ecx, 1
			mov	dword [SCREEN_LINE_LENGTH], ebx
			mul	dword ebx
			add	dword ecx, eax
			mov	dword edx, [X_START]
			add	dword ecx, [p__fb_address]
			shl	dword edx, 3
			mov	dword eax, [Y_START]
			sub	dword ecx, edx
			mul	dword ebx
			sub	dword ecx, eax
			and	byte  cl, 0fch		;dword align
			mov	dword [SCREEN_START], ecx
			mov	dword [SCREEN], ecx
			mov	dword [DECODE_FUNCTIONS + VICDECODE_BORDER], decode_border_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_WINDOW], decode_window_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_OVERSCAN], decode_overscan_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_BORDER], decode_cycle_border_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_LEFT], decode_cycle_window_left_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_CENTRAL], decode_cycle_window_central_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_RIGHT1], decode_cycle_window_right1_8bpp
			mov	dword [DECODE_FUNCTIONS + VICDECODE_CYCLE_WINDOW_RIGHT2], decode_cycle_window_right2_8bpp
			ret
;********************************************* karsten.scheibler@bigfoot.de *

