;****************************************************************************
;****************************************************************************
;*
;* defines.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef DEFINES_INC
%define DEFINES_INC





;****************************************************************************
;****************************************************************************
;*
;* PART 1: Global define's & assign's
;*
;****************************************************************************
;****************************************************************************




%define EC64_VERSION	"0.09"

%assign C64_CLOCK	982800	;Hz = 50 (frames/s) * 312 (lines/frame) * 63 (cycles/line)
%assign VC1541_CLOCK	995134	;Hz

%assign NULL		0

%assign NOT8		0ffh
%assign NOT16		0ffffh
%assign NOT32		0ffffffffh

%define CPU65XX_GLOBAL_ID	065ff0000h
%define VIC6569_GLOBAL_ID	065690000h
%define SID6581_GLOBAL_ID	065810000h
%define CIA6526_GLOBAL_ID	065260000h
%define C64MEMORY_GLOBAL_ID	000640000h
%define C64LINK_GLOBAL_ID	000640100h
%define VIA6522_GLOBAL_ID	065220000h
%define DISC_GLOBAL_ID		015410000h
%define VC1541MEMORY_GLOBAL_ID	015410100h
%define VC1541LINK_GLOBAL_ID	015410200h





;****************************************************************************
;****************************************************************************
;*
;* PART 2: Define's which set other define's
;*
;****************************************************************************
;****************************************************************************





%define MAKE_RELEASE



;%define TEST_VIA
;%define TEST_VIDEO_MODE
%define FRAME_PROFILING
%define DISABLE_SOUND_OUTPUT




;****************************************************************************
;****************************************************************************
;*
;* PART 2.1: Simple define's
;*
;****************************************************************************
;****************************************************************************





;****************************************************************************
;* define's used in path system/ ********************************************
;****************************************************************************
;%define SYSTEM_TEST_VIDEO_MODE

%define CMDLINE_FB_DEVICE	"/dev/fb0"
%define CMDLINE_AUDIO_DEVICE	"/dev/dsp"

;%define TTY_ENABLE_AUTOMATIC_INPUT

;%define AUDIO_DISABLE_SOUND_OUTPUT

;%define FB_TEST_VIDEO_MODE
%define FB_ENABLE_4BPP
%define FB_ENABLE_8BPP

;%define SYNC_DISABLE_SLEEP

;%define LOG_ENABLE



;****************************************************************************
;* define's used in path core/ **********************************************
;****************************************************************************
;%define CORE_TEST_MODULES
;%define CORE_TEST_MODULE_CPU65XX
;%define CORE_CYCLE_PROFILING

;%define C64LINK_LOG
;%define C64LINK_LOG_EVERY_UNDERFLOW

;%define C64MEMORY_LOG
;%define C64MEMORY_LOG_SAVE_RAM
;%define C64MEMORY_INCLUDE_PROGRAM
;%define C64MEMORY_PROGRAM_PATH	"../../../tests/images/cia1.prg"
;%define C64MEMORY_PROGRAM_PATH	"../../../tests/images/CIA1TAB.P00"
;%define C64MEMORY_INCLUDE_MONITOR
;%define C64MEMORY_MONITOR_PATH	"../../../tests/images/c64_monitor.prg"
;%define C64MEMORY_TEST_VIA
;%define C64MEMORY_CHECK
;%define C64MEMORY_CHECK_STACK

;%define CPU65XX_LOG
;%define CPU65XX_LOG_EVERY_OPCODE
%define CPU65XX_DISABLE_ILLEGAL_OPCODES
;%define CPU65XX_DISABLE_SED
;%define CPU65XX_USE_RESET_ADDRESS			01000h

%define CPU65XX_ENABLE_TIMESTAMPS

;%define VIC6569_DISABLE_NEW_BUS_CYCLE_15
;%define VIC6569_LOG
;%define VIC6569_LOG_EVERY_READ
;%define VIC6569_LOG_EVERY_WRITE
;%define VIC6569_DISABLE_SELECTIVE_DECODING
%define VIC6569_ENABLE_4BPP
%define VIC6569_ENABLE_8BPP

;%define SID6581_DISABLE_SOUND_OUTPUT

;%define CIA6526_LOG

;%define VC1541LINK_LOG
;%define VC1541LINK_LOG_EVERY_UNDERFLOW

;%define VC1541MEMORY_LOG
;%define VC1541MEMORY_LOG_SWITCHES
;%define VC1541MEMORY_CHECK
;%define VC1541MEMORY_CHECK_STACK
;%define VC1541MEMORY_CHECK_KERNEL

;%define VIA6522_LOG
;%define VIA6522_LOG_EVERY_READ
;%define VIA6522_LOG_EVERY_WRITE

;%define DISC_LOG
;%define DISC_INCLUDE_D64
;%define DISC_D64_PATH		"../../../../disks/turrican-side1.d64"




;****************************************************************************
;****************************************************************************
;*
;* PART 2.2: Setting these other define's if needed
;*
;****************************************************************************
;****************************************************************************





%ifdef MAKE_RELEASE
%undef TEST_VIA
%define FRAME_PROFILING
%define DISABLE_SOUND_OUTPUT
%undef TTY_ENABLE_AUTOMATIC_INPUT
%define FB_ENABLE_4BPP
%define FB_ENABLE_8BPP
%undef SYNC_DISABLE_SLEEP
%undef LOG_ENABLE
%undef CORE_TEST_MODULES
%undef CORE_CYCLE_PROFILING
%undef C64LINK_LOG
%undef C64MEMORY_LOG
%undef C64MEMORY_CHECK
%undef C64MEMORY_INCLUDE_PROGRAM
%undef C64MEMORY_INCLUDE_MONITOR
%undef CPU65XX_LOG
%undef CPU65XX_DISABLE_SED
%undef VIC6569_LOG
%undef SID6581_LOG
%undef CIA6526_LOG
%undef VC1541LINK_LOG
%undef VC1541MEMORY_LOG
%undef VC1541MEMORY_CHECK
%undef VIA6522_LOG
%undef DISC_LOG
%undef DISC_INCLUDE_D64
%endif

%ifdef FRAME_PROFILING
%define SYNC_FRAME_PROFILING
%define SYNC_FRAMES		32
%define SYNC_FRAME_BITS		5
%define CORE_FRAME_PROFILING
%define LINK_FRAME_PROFILING
%define STATUS_FRAME_PROFILING
%else
%undef SYNC_FRAME_PROFILING
%undef SYNC_FRAMES
%undef SYNC_FRAME_BITS
%undef CORE_FRAME_PROFILING
%undef LINK_FRAME_PROFILING
%undef STATUS_FRAME_PROFILING
%endif

%ifdef TEST_VIA
%define C64LINK_TEST_VIA
%define CORE_TEST_VIA
%define C64MEMORY_TEST_VIA
%else
%undef C64LINK_TEST_VIA
%undef CORE_TEST_VIA
%undef C64MEMORY_TEST_VIA
%endif

%ifdef DISABLE_SOUND_OUTPUT
%define SID6581_DISABLE_SOUND_OUTPUT
%define AUDIO_DISABLE_SOUND_OUTPUT
%else
%undef SID6581_DISABLE_SOUND_OUTPUT
%undef AUDIO_DISABLE_SOUND_OUTPUT
%endif

%ifdef TEST_VIDEO_MODE
%define SYSTEM_TEST_VIDEO_MODE
%define FB_TEST_VIDEO_MODE
%else
%undef SYSTEM_TEST_VIDEO_MODE
%undef FB_TEST_VIDEO_MODE
%endif

%ifdef C64LINK_LOG
%define LOG_ENABLE
%endif
%ifdef C64MEMORY_LOG
%define LOG_ENABLE
%endif
%ifdef CPU65XX_LOG
%define LOG_ENABLE
%endif
%ifdef VIC6569_LOG
%define LOG_ENABLE
%endif
%ifdef SID6581_LOG
%define LOG_ENABLE
%endif
%ifdef CIA6526_LOG
%define LOG_ENABLE
%endif
%ifdef VC1541LINK_LOG
%define LOG_ENABLE
%endif
%ifdef VC1541MEMORY_LOG
%define LOG_ENABLE
%endif
%ifdef VIA6522_LOG
%define LOG_ENABLE
%endif
%ifdef DISC_LOG
%define LOG_ENABLE
%endif

%endif
;********************************************* karsten.scheibler@bigfoot.de *

