;****************************************************************************
;****************************************************************************
;*
;* audio.nasm
;*
;****************************************************************************
;****************************************************************************





%define AUDIO_NASM
%include "audio.inc"
%include "syscall.inc"
%include "print.inc"


;****************************************************************************
;* some data ****************************************************************
;****************************************************************************
section .data
p__audio_device:	dd	0



;****************************************************************************
;* audio_set_device *********************************************************
;****************************************************************************
section .text
audio_set_device:
			mov	dword [p__audio_device], eax
			ret



%ifdef AUDIO_DISABLE_SOUND_OUTPUT
;****************************************************************************
;* audio_print_info *********************************************************
;****************************************************************************
section .text
audio_print_info:
			PRINT_TEXT  .cb__no_audio
			ret

.cb__no_audio:		db	10, "Audio:     Output is disabled", 10, 0



;****************************************************************************
;* audio_open ***************************************************************
;****************************************************************************
section .text
audio_open:
			ret



;****************************************************************************
;* audio_play ***************************************************************
;****************************************************************************
section .text
audio_play:
			ret



;****************************************************************************
;* audio_samples_left *******************************************************
;****************************************************************************
section .text
audio_samples_left:
			ret



;****************************************************************************
;* audio_close **************************************************************
;****************************************************************************
section .text
audio_close:
			ret



%else
;****************************************************************************
;* some more data ***********************************************************
;****************************************************************************
section .data
d__samples_left:	dd	0
d__audio_handle:	dd	0



;****************************************************************************
;* audio_print_info *********************************************************
;****************************************************************************
section .text
audio_print_info:
			PRINT_TEXT  .cb__parameters
			ret

.cb__no_audio:		db	10, "Audio:     SUPPORT ENABLED, BUT USELESS", 10, 0



;****************************************************************************
;* audio_open ***************************************************************
;****************************************************************************
section .text
audio_open:
			;----
			;open
			;----

			SYSE_OPEN  [p__audio_device], O_WRONLY
			mov	dword [d__audio_handle], eax

			;-------
			;ioctl's
			;-------

			mov	dword ebx, .ad__ioctl_table
.loop:			mov	dword ecx, [ebx]
			test	dword ecx, ecx
			jz	.end
			add	dword ebx, 4
			mov	dword edx, ebx
			push	dword ebx
			SYSE_IOCTL  [d__audio_handle]
			pop	dword ebx
			add	dword ebx, 4
			jmp	.loop
.end:			ret

.cb__error_message:	db	"Error while opening audio device", 0

section .data
			align 4
.ad__ioctl_table:	dd	SOUND_PCM_RESET, NULL
			dd	SOUND_PCM_NONBLOCK, NULL
			dd	SOUND_PCM_WRITE_RATE, 44100
			dd	SOUND_PCM_WRITE_BITS, AFMT_S16_LE
			dd	SOUND_PCM_WRITE_CHANNELS, 1
			dd	SOUND_MIXER_WRITE_PCM, 04040h
			dd	SOUND_MIXER_WRITE_VOLUME, 04040h
			dd	0, 0



;****************************************************************************
;* audio_play ***************************************************************
;****************************************************************************
section .text
audio_play:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword ecx, eax
			mov	dword edx, ebx
			SYS_WRITE  [d__audio_handle]
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* audio_samples_left *******************************************************
;****************************************************************************
section .text
audio_samples_left:	
			SYS_IOCTL  [d__audio_handle], SOUND_PCM_GETODELAY, d__samples_left
			ret



;****************************************************************************
;* audio_close **************************************************************
;****************************************************************************
section .text
audio_close:
			push	dword eax
			push	dword ebx
			mov	dword ebx, [d__audio_handle]
			test	dword ebx, ebx
			jz	.no_close
			SYS_CLOSE  [d__audio_handle]
.no_close:		pop	dword ebx
			pop	dword eax
			ret

%endif
;********************************************* karsten.scheibler@bigfoot.de *

