;****************************************************************************
;****************************************************************************
;*
;* cmdline.nasm
;*
;****************************************************************************
;****************************************************************************




%define CMDLINE_NASM
%include "cmdline.inc"
%include "syscall.inc"
%include "fb.inc"
%include "audio.inc"
%include "disc.inc"



;****************************************************************************
;* cmdline_parse ************************************************************
;****************************************************************************
section .text
cmdline_parse:
			mov	dword ecx, [ebp]	;number of arguments
			xor	dword eax, eax
			cmp	dword ecx, 1		;are there arguments ?
			jna	.end

			;--------------------------------
			;skip first argument at [ebp + 4]
			;--------------------------------

			SYSE_OPEN  [ebp + 8], O_RDONLY
			push	dword eax
			SYSE_READ  eax, ab__d64, CMDLINE_D64_SIZE
			pop	dword ebx
			SYSE_CLOSE
			mov	dword eax, ab__d64
.end:			call	disc_load_d64
			mov	dword eax, .cb__fb_device
			call	fb_set_device
			mov	dword eax, .cb__audio_device
			call	audio_set_device
			ret

.cb__error_message:	db	"Error while opening the D64 Image", 0
.cb__fb_device:		db	CMDLINE_FB_DEVICE, 0
.cb__audio_device:	db	CMDLINE_AUDIO_DEVICE, 0

section .bss
ab__d64:		resb	CMDLINE_D64_SIZE
;********************************************* karsten.scheibler@bigfoot.de *

