;****************************************************************************
;****************************************************************************
;*
;* error.nasm
;*
;****************************************************************************
;****************************************************************************




%define ERROR_NASM
%include "error.inc"
%include "syscall.inc"
%include "system.inc"
%include "print.inc"



;****************************************************************************
;* error_initialize *********************************************************
;****************************************************************************
section .text
error_initialize:
			push	dword ebx
			test	byte  [flag__offsets_initialized], NOT8
			jnz	.end
			push	dword eax
			push	dword ecx
			push	dword edx
			push	dword edi
			inc	byte  [flag__offsets_initialized]
			xor	byte  al, al
			mov	dword ebx, ap__message_offsets
			mov	dword edx, ERROR_NUMBERS
			mov	dword edi, acb__messages
			cld
.get_offsets:		mov	dword ecx, ERROR_MAX_LENGTH
			mov	dword [ebx], edi
			repne scasb
			add	dword ebx, 4
			dec	dword edx
			jnz	.get_offsets
			pop	dword edi
			pop	dword edx
			pop	dword ecx
			pop	dword eax
.end:			xor	dword ebx, ebx
			dec	dword ebx
			sub	dword ebx, eax
			inc	dword ebx
			cmp	dword ebx, ERROR_NUMBERS
			jb	.known_error
			xor	dword ebx, ebx
.known_error:		mov	dword eax, [ap__message_offsets + 4 * ebx]
			pop	dword ebx
			ret



;****************************************************************************
;* error_message ************************************************************
;****************************************************************************
section .text
error_message:
			call	system_restore
			PRINT_TEXT  cb__error_message, ebx
			test	dword eax, eax
			jz	.end
			push	dword eax
			call	error_initialize
			PRINT_TEXT  cb__error_message, eax
			pop	dword eax
.end:			ret



;****************************************************************************
;* error_exit ***************************************************************
;****************************************************************************
section .text
error_exit:
			call	system_restore
			PRINT_TEXT  cb__error_message, eax
			jmp	system_exit



;****************************************************************************
;* error_code_exit **********************************************************
;****************************************************************************
section .text
error_code_exit:
			call	system_restore
			PRINT_TEXT  cb__error_message, ebx
			test	dword eax, eax
			jz	.end
			call	error_initialize
			PRINT_TEXT  cb__error_message, eax
.end:			jmp	system_exit



;****************************************************************************
;* messages *****************************************************************
;****************************************************************************
acb__messages:		db	"Unknown Error", 0
			db	"Operation not permitted", 0
			db	"No such file or directory", 0
			db	"No such process", 0
			db	"Interrupted system call", 0
			db	"I/O error", 0
			db	"No such device or address", 0
			db	"Arg list too long", 0
			db	"Exec format error", 0
			db	"Bad file number", 0
			db	"No child processes", 0
			db	"Try again", 0
			db	"Out of memory", 0 
			db	"Permission denied", 0
			db	"Bad address", 0
			db	"Block device required", 0
			db	"Device or resource busy", 0
			db	"File exists", 0
			db	"Cross-device link", 0
			db	"No such device", 0
			db	"Not a directory", 0
			db	"Is a directory", 0
			db	"Invalid argument", 0
			db	"File table overflow", 0
			db	"Too many open files", 0
			db	"Not a typewriter", 0
			db	"Text file busy", 0
			db	"File too large", 0
			db	"No space left on device", 0
			db	"Illegal seek", 0
			db	"Read-only file system", 0
			db	"Too many links", 0
			db	"Broken pipe", 0
			db	"Math argument out of domain of func", 0
			db	"Math result not representable", 0
			db	"Resource deadlock would occur", 0
			db	"File name too long", 0
			db	"No record locks available", 0
			db	"Function not implemented", 0
			db	"Directory not empty", 0
			db	"Too many symbolic links encountered", 0
			db	"Operation would block", 0
			db	"No message of desired type", 0
			db	"Identifier removed", 0
			db	"Channel number out of range", 0
			db	"Level 2 not synchronized", 0
			db	"Level 3 halted", 0
			db	"Level 3 reset", 0
			db	"Link number out of range", 0
			db	"Protocol driver not attached", 0
			db	"No CSI structure available", 0
			db	"Level 2 halted", 0
			db	"Invalid exchange", 0
			db	"Invalid request descriptor", 0
			db	"Exchange full", 0
			db	"No anode", 0
			db	"Invalid request code", 0
			db	"Invalid slot", 0
			db	"unused errormessage!", 0
			db	"Bad font file format", 0
			db	"Device not a stream", 0
			db	"No data available", 0
			db	"Timer expired", 0
			db	"Out of streams resources", 0
			db	"Machine is not on the network", 0
			db	"Package not installed", 0
			db	"Object is remote", 0
			db	"Link has been severed", 0
			db	"Advertise error", 0
			db	"Srmount error", 0
			db	"Communication error on send", 0
			db	"Protocol error", 0
			db	"Multihop attempted", 0
			db	"RFS specific error", 0
			db	"Not a data message", 0
			db	"Value too large for defined data type", 0
			db	"Name not unique on network", 0
			db	"File descriptor in bad state", 0
			db	"Remote address changed", 0
			db	"Can not access a needed shared library", 0
			db	"Accessing a corrupted shared library", 0
			db	".lib section in a.out corrupted", 0
			db	"Attempting to link in too many shared libraries", 0
			db	"Cannot exec a shared library directly", 0
			db	"Illegal byte sequence", 0
			db	"Interrupted system call should be restarted", 0
			db	"Streams pipe error", 0
			db	"Too many users", 0
			db	"Socket operation on non-socket", 0
			db	"Destination address required", 0
			db	"Message too long", 0
			db	"Protocol wrong type for socket", 0
			db	"Protocol not available", 0
			db	"Protocol not supported", 0
			db	"Socket type not supported", 0
			db	"Operation not supported on transport endpoint", 0
			db	"Protocol family not supported", 0
			db	"Address family not supported by protocol", 0
			db	"Address already in use", 0
			db	"Cannot assign requested address", 0
			db	"Network is down", 0
			db	"Network is unreachable", 0
			db	"Network dropped connection because of reset", 0
			db	"Software caused connection abort", 0
			db	"Connection reset by peer", 0
			db	"No buffer space available", 0
			db	"Transport endpoint is already connected", 0
			db	"Transport endpoint is not connected", 0
			db	"Cannot send after transport endpoint shutdown", 0
			db	"Too many references: cannot splice", 0
			db	"Connection timed out", 0
			db	"Connection refused", 0
			db	"Host is down", 0
			db	"No route to host", 0
			db	"Operation already in progress", 0
			db	"Operation now in progress", 0
			db	"Stale NFS file handle", 0
			db	"Structure needs cleaning", 0
			db	"Not a XENIX named type file", 0
			db	"No XENIX semaphores available", 0
			db	"Is a named type file", 0
			db	"Remote I/O error", 0
			db	"Quota exceeded", 0
			db	"No medium found", 0
			db	"Wrong medium type", 0

cb__error_message:	db	"ec64: ", STRING_INSERT_STR, 10, 0



;****************************************************************************
;* some data ****************************************************************
;****************************************************************************
section .data
flag__offsets_initialized:	db	0

section .bss
			alignb 4
ap__message_offsets:	resd	ERROR_NUMBERS
;********************************************* karsten.scheibler@bigfoot.de *

