;****************************************************************************
;****************************************************************************
;*
;* fb.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef FB_INC
%define FB_INC

%include "defines.inc"

%include "string.inc"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef FB_NASM
global fb_set_device
global fb_print_info
global fb_open
global fb_initialize
global fb_clear
global fb_write
global fb_draw_line
global fb_draw_led
global fb_draw_text
global fb_draw_string
global fb_close
global fb_get_parameter
%ifdef FB_TEST_VIDEO_MODE
global fb_test
%endif
%else
extern fb_set_device
extern fb_print_info
extern fb_open
extern fb_initialize
extern fb_clear
extern fb_write
extern fb_draw_line
extern fb_draw_led
extern fb_draw_text
extern fb_draw_string
extern fb_close
extern fb_get_parameter
%ifdef FB_TEST_VIDEO_MODE
extern fb_test
%endif
%endif



;****************************************************************************
;* Structures ***************************************************************
;****************************************************************************
				struc fbfunc
				alignb 4
p__fbfunc_initialize:		resd	1
p__fbfunc_clear:		resd	1
p__fbfunc_draw_line:		resd	1
p__fbfunc_draw_led:		resd	1
p__fbfunc_draw:			resd	1
				endstruc


;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%define FBFUNC_INITIALIZE	p__fbfunc_initialize
%define FBFUNC_CLEAR		p__fbfunc_clear
%define FBFUNC_DRAW_LINE	p__fbfunc_draw_line
%define FBFUNC_DRAW_LED		p__fbfunc_draw_led
%define FBFUNC_DRAW		p__fbfunc_draw

%assign FB_VGA_IO_BASE			003c4h
%assign FB_VGA_IO_SIZE			12
%assign FB_VGA_SEQUENCER_BASE		003c4h
%assign FB_VGA_SEQUENCER_REGISTERS	5
%assign FB_VGA_GRAPHICS_BASE		003ceh
%assign FB_VGA_GRAPHICS_REGISTERS	9
%assign FB_4BPP_MODE			1
%assign FB_8BPP_MODE			2

%assign FB_DRAW_MAX_STRING_LENGTH	00100h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro FB_DRAW_TEXT 4-*
%define FB_DRAW_X	%1
%define FB_DRAW_Y	%2
%define FB_DRAW_LENGTH	%3
%define FB_DRAW_POINTER	%4
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
%if %0 > 4
			push	dword ebp
			mov	dword ebp, esp
%rep %0-4
%rotate 1
%ifidn %4, ebp
%error "FB_DRAW_TEXT: can't use ebp as Parameter"
%endif
			push	dword %4
%endrep
%endif
			mov	dword eax, FB_DRAW_POINTER
			mov	dword ebx, FB_DRAW_X
			mov	dword ecx, FB_DRAW_Y
			mov	dword edx, FB_DRAW_LENGTH
%if %0 > 4
			call	fb_draw_string
			mov	dword esp, ebp
			pop	dword ebp
%else
			call	fb_draw_text
%endif
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
%undef FB_DRAW_POINTER
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

