;****************************************************************************
;****************************************************************************
;*
;* print.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef PRINT_INC
%define PRINT_INC

%include "defines.inc"

%include "string.inc"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef PRINT_NASM
global print_text
global print_string
%else
extern print_text
extern print_string
%endif



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%assign PRINT_MAX_STRING_LENGTH		01000h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro PRINT_TEXT 1-*
%define PRINT_POINTER	%1
			push	dword eax
%if %0 > 1
			push	dword ebp
			mov	dword ebp, esp
%rep %0-1
%rotate 1
%ifidn %1, ebp
%error "PRINT_TEXT: can't use ebp as Parameter"
%endif
			push	dword %1
%endrep
%endif
			mov	dword eax, PRINT_POINTER
%if %0 > 1
			call	print_string
			mov	dword esp, ebp
			pop	dword ebp
%else
			call	print_text
%endif
			pop	dword eax
%undef PRINT_POINTER
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

